require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_SPARC_PROCESSOR_H)) {
    eval 'sub __ASM_SPARC_PROCESSOR_H () {1;}' unless defined(&__ASM_SPARC_PROCESSOR_H);
    eval 'sub current_text_addr () {
        eval q(({  &void * &pc;  &__asm__(\\"sethi %%hi(1f), %0; or %0, %%lo(1f), %0;\\\\n1:\\" : \\"=r\\" ( &pc));  &pc; }));
    }' unless defined(&current_text_addr);
    require 'linux/a.out.ph';
    require 'asm/psr.ph';
    require 'asm/ptrace.ph';
    require 'asm/head.ph';
    require 'asm/signal.ph';
    require 'asm/segment.ph';
    require 'asm/btfixup.ph';
    require 'asm/page.ph';
    require 'asm/atomic.ph';
    eval 'sub EISA_bus () {0;}' unless defined(&EISA_bus);
    eval 'sub EISA_bus__is_a_macro () {1;}' unless defined(&EISA_bus__is_a_macro);
    eval 'sub MCA_bus () {0;}' unless defined(&MCA_bus);
    eval 'sub MCA_bus__is_a_macro () {1;}' unless defined(&MCA_bus__is_a_macro);
    eval 'sub wp_works_ok () {1;}' unless defined(&wp_works_ok);
    eval 'sub wp_works_ok__is_a_macro () {1;}' unless defined(&wp_works_ok__is_a_macro);
    eval 'sub TASK_SIZE () { &PAGE_OFFSET;}' unless defined(&TASK_SIZE);
    eval 'sub NSWINS () {8;}' unless defined(&NSWINS);
    eval 'sub SPARC_FLAG_KTHREAD () {0x1;}' unless defined(&SPARC_FLAG_KTHREAD);
    eval 'sub SPARC_FLAG_UNALIGNED () {0x2;}' unless defined(&SPARC_FLAG_UNALIGNED);
    eval 'sub INIT_THREAD () {{ 0, 0, 0, 0, 0, 0, 0, 0, { { { 0, }, { 0, } }, }, { 0, 0, 0, 0, 0, 0, 0, 0, }, 0, { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, }, 0, 0, { { 0, 0, }, },  &SPARC_FLAG_KTHREAD,  &KERNEL_DS, { 0, }, 0, };}' unless defined(&INIT_THREAD);
    eval 'sub release_thread {
        local($tsk) = @_;
	    eval q( &do { }  &while(0));
    }' unless defined(&release_thread);
    eval 'sub copy_segments {
        local($tsk, $mm) = @_;
	    eval q( &do { }  &while (0));
    }' unless defined(&copy_segments);
    eval 'sub release_segments {
        local($mm) = @_;
	    eval q( &do { }  &while (0));
    }' unless defined(&release_segments);
    eval 'sub get_wchan {
        local($__TSK) = @_;
	    eval q(({  &extern  &void  &scheduling_functions_start_here;  &extern  &void  &scheduling_functions_end_here; \'unsigned long pc\',  &fp,  &bias = 0; \'unsigned long task_base\' = ; \'unsigned long __ret\' = 0; \'struct reg_window\' * &rw; \'int\'  &count = 0;  &if (! || ==  &current || -> &state ==  &TASK_RUNNING)  &goto  &__out;  &fp = -> ($thread->{ksp}) +  &bias;  &do {  &if ( &fp < ( &task_base +  &sizeof) ||  &fp >= ( &task_base + (2*  &PAGE_SIZE)))  &break;  &rw =  &fp;  &pc =  ($rw->{ins[7]});  &if ( &pc < ||  &pc >= (  &scheduling_functions_end_here)) {  &__ret =  &pc;  &goto  &__out; }  &fp =  ($rw->{ins[6]}) +  &bias; }  &while (++ &count < 16);  &__out:  &__ret; }));
    }' unless defined(&get_wchan);
    eval 'sub KSTK_EIP {
        local($tsk) = @_;
	    eval q((($tsk)-> ($thread->{kregs}->{pc})));
    }' unless defined(&KSTK_EIP);
    eval 'sub KSTK_ESP {
        local($tsk) = @_;
	    eval q((($tsk)-> ($thread->{kregs}->{u_regs[&UREG_FP]})));
    }' unless defined(&KSTK_ESP);
    if(defined(&__KERNEL__)) {
	eval 'sub THREAD_SIZE () {(2* &PAGE_SIZE);}' unless defined(&THREAD_SIZE);
	eval 'sub alloc_task_struct () {
	    eval q( &BTFIXUP_CALL());
	}' unless defined(&alloc_task_struct);
	eval 'sub free_task_struct {
	    local($tsk) = @_;
    	    eval q( &BTFIXUP_CALL($tsk));
	}' unless defined(&free_task_struct);
	eval 'sub get_task_struct {
	    local($tsk) = @_;
    	    eval q( &BTFIXUP_CALL($tsk));
	}' unless defined(&get_task_struct);
	eval 'sub init_task () {( ($init_task_union->{task}));}' unless defined(&init_task);
	eval 'sub init_stack () {( ($init_task_union->{stack}));}' unless defined(&init_stack);
	eval 'sub cpu_relax () {
	    eval q( &barrier());
	}' unless defined(&cpu_relax);
    }
}
1;
