require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SPARC_SBUS_H)) {
    eval 'sub _SPARC_SBUS_H () {1;}' unless defined(&_SPARC_SBUS_H);
    require 'linux/ioport.ph';
    require 'asm/oplib.ph';
    require 'asm/iommu.ph';
    require 'asm/scatterlist.ph';
    eval 'sub SUN_SBUS_BVADDR () {0xf8000000;}' unless defined(&SUN_SBUS_BVADDR);
    eval 'sub SBUS_OFF_MASK () {0x1ffffff;}' unless defined(&SBUS_OFF_MASK);
    eval 'sub for_each_sbus {
        local($bus) = @_;
	    eval q( &for(($bus) =  &sbus_root; ($bus); ($bus)=($bus)-> &next));
    }' unless defined(&for_each_sbus);
    eval 'sub for_each_sbusdev {
        local($device, $bus) = @_;
	    eval q( &for(($device) = ($bus)-> &devices; ($device); ($device)=($device)-> &next));
    }' unless defined(&for_each_sbusdev);
    eval 'sub for_all_sbusdev {
        local($device, $bus) = @_;
	    eval q( &for (($bus) =  &sbus_root; ($bus); ($bus) = ($bus)-> &next)  &for (($device) = ($bus)-> &devices; ($device); ($device) = ($device)-> &next));
    }' unless defined(&for_all_sbusdev);
    eval 'sub sbus_can_dma_64bit {
        local($sdev) = @_;
	    eval q((0));
    }' unless defined(&sbus_can_dma_64bit);
    eval 'sub sbus_can_burst64 {
        local($sdev) = @_;
	    eval q((0));
    }' unless defined(&sbus_can_burst64);
    eval 'sub SBUS_DMA_BIDIRECTIONAL () {0;}' unless defined(&SBUS_DMA_BIDIRECTIONAL);
    eval 'sub SBUS_DMA_TODEVICE () {1;}' unless defined(&SBUS_DMA_TODEVICE);
    eval 'sub SBUS_DMA_FROMDEVICE () {2;}' unless defined(&SBUS_DMA_FROMDEVICE);
    eval 'sub SBUS_DMA_NONE () {3;}' unless defined(&SBUS_DMA_NONE);
    eval 'sub sbint_to_irq {
        local($sdev, $sbint) = @_;
	    eval q( &BTFIXUP_CALL($sdev, $sbint));
    }' unless defined(&sbint_to_irq);
}
1;
