require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__SPARC_CHECKSUM_H)) {
    eval 'sub __SPARC_CHECKSUM_H () {1;}' unless defined(&__SPARC_CHECKSUM_H);
    require 'linux/in6.ph';
    require 'asm/uaccess.ph';
    require 'asm/cprefix.ph';
    eval 'sub csum_partial_copy {
        local($src, $dst, $len, $sum) = @_;
	    eval q( &csum_partial_copy_nocheck($src,$dst,$len,$sum));
    }' unless defined(&csum_partial_copy);
    eval 'sub csum_partial_copy_fromuser {
        local($s, $d, $l, $w) = @_;
	    eval q( &csum_partial_copy( ($s), ($d), ($l), ($w)));
    }' unless defined(&csum_partial_copy_fromuser);
    eval 'sub HAVE_CSUM_COPY_USER () {1;}' unless defined(&HAVE_CSUM_COPY_USER);
    eval 'sub csum_and_copy_to_user () { &csum_partial_copy_to_user;}' unless defined(&csum_and_copy_to_user);
    eval 'sub _HAVE_ARCH_IPV6_CSUM () {1;}' unless defined(&_HAVE_ARCH_IPV6_CSUM);
}
1;
