require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__SPARC_PCI_H)) {
    eval 'sub __SPARC_PCI_H () {1;}' unless defined(&__SPARC_PCI_H);
    if(defined(&__KERNEL__)) {
	eval 'sub pcibios_assign_all_busses () {
	    eval q(0);
	}' unless defined(&pcibios_assign_all_busses);
	eval 'sub pcibios_scan_all_fns () {
	    eval q(0);
	}' unless defined(&pcibios_scan_all_fns);
	eval 'sub PCIBIOS_MIN_IO () {0;}' unless defined(&PCIBIOS_MIN_IO);
	eval 'sub PCIBIOS_MIN_MEM () {0;}' unless defined(&PCIBIOS_MIN_MEM);
	eval 'sub PCI_IRQ_NONE () {0xffffffff;}' unless defined(&PCI_IRQ_NONE);
	eval 'sub PCI_DMA_BUS_IS_PHYS () {(0);}' unless defined(&PCI_DMA_BUS_IS_PHYS);
	require 'asm/scatterlist.ph';
	eval 'sub DECLARE_PCI_UNMAP_ADDR {
	    local($ADDR_NAME) = @_;
    	    eval q( &dma_addr_t $ADDR_NAME;);
	}' unless defined(&DECLARE_PCI_UNMAP_ADDR);
	eval 'sub DECLARE_PCI_UNMAP_LEN {
	    local($LEN_NAME) = @_;
    	    eval q( &__u32 $LEN_NAME;);
	}' unless defined(&DECLARE_PCI_UNMAP_LEN);
	eval 'sub pci_unmap_addr {
	    local($PTR, $ADDR_NAME) = @_;
    	    eval q((($PTR)->$ADDR_NAME));
	}' unless defined(&pci_unmap_addr);
	eval 'sub pci_unmap_addr_set {
	    local($PTR, $ADDR_NAME, $VAL) = @_;
    	    eval q(((($PTR)->$ADDR_NAME) = ($VAL)));
	}' unless defined(&pci_unmap_addr_set);
	eval 'sub pci_unmap_len {
	    local($PTR, $LEN_NAME) = @_;
    	    eval q((($PTR)->$LEN_NAME));
	}' unless defined(&pci_unmap_len);
	eval 'sub pci_unmap_len_set {
	    local($PTR, $LEN_NAME, $VAL) = @_;
    	    eval q(((($PTR)->$LEN_NAME) = ($VAL)));
	}' unless defined(&pci_unmap_len_set);
	eval 'sub pci_dac_dma_supported {
	    local($dev, $mask) = @_;
    	    eval q((0));
	}' unless defined(&pci_dac_dma_supported);
	eval 'sub pci_controller_num {
	    local($PDEV) = @_;
    	    eval q((0));
	}' unless defined(&pci_controller_num);
    }
}
1;
