require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SPARC64_KEYBOARD_H)) {
    eval 'sub _SPARC64_KEYBOARD_H () {1;}' unless defined(&_SPARC64_KEYBOARD_H);
    if(defined(&__KERNEL__)) {
	require 'linux/kernel.ph';
	require 'linux/kd.ph';
	eval 'sub KEYBOARD_IRQ () {1;}' unless defined(&KEYBOARD_IRQ);
	eval 'sub DISABLE_KBD_DURING_INTERRUPTS () {0;}' unless defined(&DISABLE_KBD_DURING_INTERRUPTS);
	eval 'sub kbd_setkeycode () { &pcikbd_setkeycode;}' unless defined(&kbd_setkeycode);
	eval 'sub kbd_getkeycode () { &pcikbd_getkeycode;}' unless defined(&kbd_getkeycode);
	eval 'sub kbd_translate () { &pcikbd_translate;}' unless defined(&kbd_translate);
	eval 'sub kbd_unexpected_up () { &pcikbd_unexpected_up;}' unless defined(&kbd_unexpected_up);
	eval 'sub kbd_leds () { &pcikbd_leds;}' unless defined(&kbd_leds);
	eval 'sub kbd_init_hw () { &pcikbd_init_hw;}' unless defined(&kbd_init_hw);
	eval 'sub kbd_sysrq_xlate () { &pcikbd_sysrq_xlate;}' unless defined(&kbd_sysrq_xlate);
	eval 'sub kbd_init () { &pcikbd_init;}' unless defined(&kbd_init);
	eval 'sub compute_shiftstate () { &pci_compute_shiftstate;}' unless defined(&compute_shiftstate);
	eval 'sub getkeycode () { &pci_getkeycode;}' unless defined(&getkeycode);
	eval 'sub setkeycode () { &pci_setkeycode;}' unless defined(&setkeycode);
	eval 'sub getledstate () { &pci_getledstate;}' unless defined(&getledstate);
	eval 'sub setledstate () { &pci_setledstate;}' unless defined(&setledstate);
	eval 'sub register_leds () { &pci_register_leds;}' unless defined(&register_leds);
	eval 'sub SYSRQ_KEY () {0x54;}' unless defined(&SYSRQ_KEY);
    }
}
1;
