require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SPARC64_SAB82532_H)) {
    eval 'sub _SPARC64_SAB82532_H () {1;}' unless defined(&_SPARC64_SAB82532_H);
    require 'linux/types.ph';
    require 'linux/serial.ph';
    require 'linux/circ_buf.ph';
    eval 'sub NR_PORTS () {2;}' unless defined(&NR_PORTS);
    eval 'sub SAB82532_ALLS () {0x1;}' unless defined(&SAB82532_ALLS);
    eval 'sub SAB82532_XPR () {0x2;}' unless defined(&SAB82532_XPR);
    eval 'sub SAB82532_RSTAT_PE () {0x80;}' unless defined(&SAB82532_RSTAT_PE);
    eval 'sub SAB82532_RSTAT_FE () {0x40;}' unless defined(&SAB82532_RSTAT_FE);
    eval 'sub SAB82532_RSTAT_PARITY () {0x1;}' unless defined(&SAB82532_RSTAT_PARITY);
    eval 'sub SAB82532_STAR_XDOV () {0x80;}' unless defined(&SAB82532_STAR_XDOV);
    eval 'sub SAB82532_STAR_XFW () {0x40;}' unless defined(&SAB82532_STAR_XFW);
    eval 'sub SAB82532_STAR_RFNE () {0x20;}' unless defined(&SAB82532_STAR_RFNE);
    eval 'sub SAB82532_STAR_FCS () {0x10;}' unless defined(&SAB82532_STAR_FCS);
    eval 'sub SAB82532_STAR_TEC () {0x8;}' unless defined(&SAB82532_STAR_TEC);
    eval 'sub SAB82532_STAR_CEC () {0x4;}' unless defined(&SAB82532_STAR_CEC);
    eval 'sub SAB82532_STAR_CTS () {0x2;}' unless defined(&SAB82532_STAR_CTS);
    eval 'sub SAB82532_CMDR_RMC () {0x80;}' unless defined(&SAB82532_CMDR_RMC);
    eval 'sub SAB82532_CMDR_RRES () {0x40;}' unless defined(&SAB82532_CMDR_RRES);
    eval 'sub SAB82532_CMDR_RFRD () {0x20;}' unless defined(&SAB82532_CMDR_RFRD);
    eval 'sub SAB82532_CMDR_STI () {0x10;}' unless defined(&SAB82532_CMDR_STI);
    eval 'sub SAB82532_CMDR_XF () {0x8;}' unless defined(&SAB82532_CMDR_XF);
    eval 'sub SAB82532_CMDR_XRES () {0x1;}' unless defined(&SAB82532_CMDR_XRES);
    eval 'sub SAB82532_MODE_FRTS () {0x40;}' unless defined(&SAB82532_MODE_FRTS);
    eval 'sub SAB82532_MODE_FCTS () {0x20;}' unless defined(&SAB82532_MODE_FCTS);
    eval 'sub SAB82532_MODE_FLON () {0x10;}' unless defined(&SAB82532_MODE_FLON);
    eval 'sub SAB82532_MODE_RAC () {0x8;}' unless defined(&SAB82532_MODE_RAC);
    eval 'sub SAB82532_MODE_RTS () {0x4;}' unless defined(&SAB82532_MODE_RTS);
    eval 'sub SAB82532_MODE_TRS () {0x2;}' unless defined(&SAB82532_MODE_TRS);
    eval 'sub SAB82532_MODE_TLP () {0x1;}' unless defined(&SAB82532_MODE_TLP);
    eval 'sub SAB82532_TIMR_CNT_MASK () {0xe0;}' unless defined(&SAB82532_TIMR_CNT_MASK);
    eval 'sub SAB82532_TIMR_VALUE_MASK () {0x1f;}' unless defined(&SAB82532_TIMR_VALUE_MASK);
    eval 'sub SAB82532_DAFO_XBRK () {0x40;}' unless defined(&SAB82532_DAFO_XBRK);
    eval 'sub SAB82532_DAFO_STOP () {0x20;}' unless defined(&SAB82532_DAFO_STOP);
    eval 'sub SAB82532_DAFO_PAR_SPACE () {0x;}' unless defined(&SAB82532_DAFO_PAR_SPACE);
    eval 'sub SAB82532_DAFO_PAR_ODD () {0x8;}' unless defined(&SAB82532_DAFO_PAR_ODD);
    eval 'sub SAB82532_DAFO_PAR_EVEN () {0x10;}' unless defined(&SAB82532_DAFO_PAR_EVEN);
    eval 'sub SAB82532_DAFO_PAR_MARK () {0x18;}' unless defined(&SAB82532_DAFO_PAR_MARK);
    eval 'sub SAB82532_DAFO_PARE () {0x4;}' unless defined(&SAB82532_DAFO_PARE);
    eval 'sub SAB82532_DAFO_CHL8 () {0x;}' unless defined(&SAB82532_DAFO_CHL8);
    eval 'sub SAB82532_DAFO_CHL7 () {0x1;}' unless defined(&SAB82532_DAFO_CHL7);
    eval 'sub SAB82532_DAFO_CHL6 () {0x2;}' unless defined(&SAB82532_DAFO_CHL6);
    eval 'sub SAB82532_DAFO_CHL5 () {0x3;}' unless defined(&SAB82532_DAFO_CHL5);
    eval 'sub SAB82532_RFC_DPS () {0x40;}' unless defined(&SAB82532_RFC_DPS);
    eval 'sub SAB82532_RFC_DXS () {0x20;}' unless defined(&SAB82532_RFC_DXS);
    eval 'sub SAB82532_RFC_RFDF () {0x10;}' unless defined(&SAB82532_RFC_RFDF);
    eval 'sub SAB82532_RFC_RFTH_1 () {0x;}' unless defined(&SAB82532_RFC_RFTH_1);
    eval 'sub SAB82532_RFC_RFTH_4 () {0x4;}' unless defined(&SAB82532_RFC_RFTH_4);
    eval 'sub SAB82532_RFC_RFTH_16 () {0x8;}' unless defined(&SAB82532_RFC_RFTH_16);
    eval 'sub SAB82532_RFC_RFTH_32 () {0xc;}' unless defined(&SAB82532_RFC_RFTH_32);
    eval 'sub SAB82532_RFC_TCDE () {0x1;}' unless defined(&SAB82532_RFC_TCDE);
    eval 'sub SAB82532_RBCH_DMA () {0x80;}' unless defined(&SAB82532_RBCH_DMA);
    eval 'sub SAB82532_RBCH_CAS () {0x20;}' unless defined(&SAB82532_RBCH_CAS);
    eval 'sub SAB82532_XBCH_DMA () {0x80;}' unless defined(&SAB82532_XBCH_DMA);
    eval 'sub SAB82532_XBCH_CAS () {0x20;}' unless defined(&SAB82532_XBCH_CAS);
    eval 'sub SAB82532_XBCH_XC () {0x10;}' unless defined(&SAB82532_XBCH_XC);
    eval 'sub SAB82532_CCR0_PU () {0x80;}' unless defined(&SAB82532_CCR0_PU);
    eval 'sub SAB82532_CCR0_MCE () {0x40;}' unless defined(&SAB82532_CCR0_MCE);
    eval 'sub SAB82532_CCR0_SC_NRZ () {0x;}' unless defined(&SAB82532_CCR0_SC_NRZ);
    eval 'sub SAB82532_CCR0_SC_NRZI () {0x8;}' unless defined(&SAB82532_CCR0_SC_NRZI);
    eval 'sub SAB82532_CCR0_SC_FM0 () {0x10;}' unless defined(&SAB82532_CCR0_SC_FM0);
    eval 'sub SAB82532_CCR0_SC_FM1 () {0x14;}' unless defined(&SAB82532_CCR0_SC_FM1);
    eval 'sub SAB82532_CCR0_SC_MANCH () {0x18;}' unless defined(&SAB82532_CCR0_SC_MANCH);
    eval 'sub SAB82532_CCR0_SM_HDLC () {0x;}' unless defined(&SAB82532_CCR0_SM_HDLC);
    eval 'sub SAB82532_CCR0_SM_SDLC_LOOP () {0x1;}' unless defined(&SAB82532_CCR0_SM_SDLC_LOOP);
    eval 'sub SAB82532_CCR0_SM_BISYNC () {0x2;}' unless defined(&SAB82532_CCR0_SM_BISYNC);
    eval 'sub SAB82532_CCR0_SM_ASYNC () {0x3;}' unless defined(&SAB82532_CCR0_SM_ASYNC);
    eval 'sub SAB82532_CCR1_ODS () {0x10;}' unless defined(&SAB82532_CCR1_ODS);
    eval 'sub SAB82532_CCR1_BCR () {0x8;}' unless defined(&SAB82532_CCR1_BCR);
    eval 'sub SAB82532_CCR1_CM_MASK () {0x7;}' unless defined(&SAB82532_CCR1_CM_MASK);
    eval 'sub SAB82532_CCR2_SOC1 () {0x80;}' unless defined(&SAB82532_CCR2_SOC1);
    eval 'sub SAB82532_CCR2_SOC0 () {0x40;}' unless defined(&SAB82532_CCR2_SOC0);
    eval 'sub SAB82532_CCR2_BR9 () {0x80;}' unless defined(&SAB82532_CCR2_BR9);
    eval 'sub SAB82532_CCR2_BR8 () {0x40;}' unless defined(&SAB82532_CCR2_BR8);
    eval 'sub SAB82532_CCR2_BDF () {0x20;}' unless defined(&SAB82532_CCR2_BDF);
    eval 'sub SAB82532_CCR2_SSEL () {0x10;}' unless defined(&SAB82532_CCR2_SSEL);
    eval 'sub SAB82532_CCR2_XCS0 () {0x20;}' unless defined(&SAB82532_CCR2_XCS0);
    eval 'sub SAB82532_CCR2_RCS0 () {0x10;}' unless defined(&SAB82532_CCR2_RCS0);
    eval 'sub SAB82532_CCR2_TOE () {0x8;}' unless defined(&SAB82532_CCR2_TOE);
    eval 'sub SAB82532_CCR2_RWX () {0x4;}' unless defined(&SAB82532_CCR2_RWX);
    eval 'sub SAB82532_CCR2_DIV () {0x1;}' unless defined(&SAB82532_CCR2_DIV);
    eval 'sub SAB82532_CCR3_PSD () {0x1;}' unless defined(&SAB82532_CCR3_PSD);
    eval 'sub SAB82532_TSAX_TSNX_MASK () {0xfc;}' unless defined(&SAB82532_TSAX_TSNX_MASK);
    eval 'sub SAB82532_TSAX_XCS2 () {0x2;}' unless defined(&SAB82532_TSAX_XCS2);
    eval 'sub SAB82532_TSAX_XCS1 () {0x1;}' unless defined(&SAB82532_TSAX_XCS1);
    eval 'sub SAB82532_TSAR_TSNR_MASK () {0xfc;}' unless defined(&SAB82532_TSAR_TSNR_MASK);
    eval 'sub SAB82532_TSAR_RCS2 () {0x2;}' unless defined(&SAB82532_TSAR_RCS2);
    eval 'sub SAB82532_TSAR_RCS1 () {0x1;}' unless defined(&SAB82532_TSAR_RCS1);
    eval 'sub SAB82532_VSTR_CD () {0x80;}' unless defined(&SAB82532_VSTR_CD);
    eval 'sub SAB82532_VSTR_DPLA () {0x40;}' unless defined(&SAB82532_VSTR_DPLA);
    eval 'sub SAB82532_VSTR_VN_MASK () {0xf;}' unless defined(&SAB82532_VSTR_VN_MASK);
    eval 'sub SAB82532_VSTR_VN_1 () {0x;}' unless defined(&SAB82532_VSTR_VN_1);
    eval 'sub SAB82532_VSTR_VN_2 () {0x1;}' unless defined(&SAB82532_VSTR_VN_2);
    eval 'sub SAB82532_VSTR_VN_3_2 () {0x2;}' unless defined(&SAB82532_VSTR_VN_3_2);
    eval 'sub SAB82532_GIS_PI () {0x80;}' unless defined(&SAB82532_GIS_PI);
    eval 'sub SAB82532_GIS_ISA1 () {0x8;}' unless defined(&SAB82532_GIS_ISA1);
    eval 'sub SAB82532_GIS_ISA0 () {0x4;}' unless defined(&SAB82532_GIS_ISA0);
    eval 'sub SAB82532_GIS_ISB1 () {0x2;}' unless defined(&SAB82532_GIS_ISB1);
    eval 'sub SAB82532_GIS_ISB0 () {0x1;}' unless defined(&SAB82532_GIS_ISB0);
    eval 'sub SAB82532_IVA_MASK () {0xf1;}' unless defined(&SAB82532_IVA_MASK);
    eval 'sub SAB82532_IPC_VIS () {0x80;}' unless defined(&SAB82532_IPC_VIS);
    eval 'sub SAB82532_IPC_SLA1 () {0x10;}' unless defined(&SAB82532_IPC_SLA1);
    eval 'sub SAB82532_IPC_SLA0 () {0x8;}' unless defined(&SAB82532_IPC_SLA0);
    eval 'sub SAB82532_IPC_CASM () {0x4;}' unless defined(&SAB82532_IPC_CASM);
    eval 'sub SAB82532_IPC_IC_OPEN_DRAIN () {0x;}' unless defined(&SAB82532_IPC_IC_OPEN_DRAIN);
    eval 'sub SAB82532_IPC_IC_ACT_LOW () {0x1;}' unless defined(&SAB82532_IPC_IC_ACT_LOW);
    eval 'sub SAB82532_IPC_IC_ACT_HIGH () {0x3;}' unless defined(&SAB82532_IPC_IC_ACT_HIGH);
    eval 'sub SAB82532_ISR0_TCD () {0x80;}' unless defined(&SAB82532_ISR0_TCD);
    eval 'sub SAB82532_ISR0_TIME () {0x40;}' unless defined(&SAB82532_ISR0_TIME);
    eval 'sub SAB82532_ISR0_PERR () {0x20;}' unless defined(&SAB82532_ISR0_PERR);
    eval 'sub SAB82532_ISR0_FERR () {0x10;}' unless defined(&SAB82532_ISR0_FERR);
    eval 'sub SAB82532_ISR0_PLLA () {0x8;}' unless defined(&SAB82532_ISR0_PLLA);
    eval 'sub SAB82532_ISR0_CDSC () {0x4;}' unless defined(&SAB82532_ISR0_CDSC);
    eval 'sub SAB82532_ISR0_RFO () {0x2;}' unless defined(&SAB82532_ISR0_RFO);
    eval 'sub SAB82532_ISR0_RPF () {0x1;}' unless defined(&SAB82532_ISR0_RPF);
    eval 'sub SAB82532_ISR1_BRK () {0x80;}' unless defined(&SAB82532_ISR1_BRK);
    eval 'sub SAB82532_ISR1_BRKT () {0x40;}' unless defined(&SAB82532_ISR1_BRKT);
    eval 'sub SAB82532_ISR1_ALLS () {0x20;}' unless defined(&SAB82532_ISR1_ALLS);
    eval 'sub SAB82532_ISR1_XOFF () {0x10;}' unless defined(&SAB82532_ISR1_XOFF);
    eval 'sub SAB82532_ISR1_TIN () {0x8;}' unless defined(&SAB82532_ISR1_TIN);
    eval 'sub SAB82532_ISR1_CSC () {0x4;}' unless defined(&SAB82532_ISR1_CSC);
    eval 'sub SAB82532_ISR1_XON () {0x2;}' unless defined(&SAB82532_ISR1_XON);
    eval 'sub SAB82532_ISR1_XPR () {0x1;}' unless defined(&SAB82532_ISR1_XPR);
    eval 'sub SAB82532_IMR0_TCD () {0x80;}' unless defined(&SAB82532_IMR0_TCD);
    eval 'sub SAB82532_IMR0_TIME () {0x40;}' unless defined(&SAB82532_IMR0_TIME);
    eval 'sub SAB82532_IMR0_PERR () {0x20;}' unless defined(&SAB82532_IMR0_PERR);
    eval 'sub SAB82532_IMR0_FERR () {0x10;}' unless defined(&SAB82532_IMR0_FERR);
    eval 'sub SAB82532_IMR0_PLLA () {0x8;}' unless defined(&SAB82532_IMR0_PLLA);
    eval 'sub SAB82532_IMR0_CDSC () {0x4;}' unless defined(&SAB82532_IMR0_CDSC);
    eval 'sub SAB82532_IMR0_RFO () {0x2;}' unless defined(&SAB82532_IMR0_RFO);
    eval 'sub SAB82532_IMR0_RPF () {0x1;}' unless defined(&SAB82532_IMR0_RPF);
    eval 'sub SAB82532_IMR1_BRK () {0x80;}' unless defined(&SAB82532_IMR1_BRK);
    eval 'sub SAB82532_IMR1_BRKT () {0x40;}' unless defined(&SAB82532_IMR1_BRKT);
    eval 'sub SAB82532_IMR1_ALLS () {0x20;}' unless defined(&SAB82532_IMR1_ALLS);
    eval 'sub SAB82532_IMR1_XOFF () {0x10;}' unless defined(&SAB82532_IMR1_XOFF);
    eval 'sub SAB82532_IMR1_TIN () {0x8;}' unless defined(&SAB82532_IMR1_TIN);
    eval 'sub SAB82532_IMR1_CSC () {0x4;}' unless defined(&SAB82532_IMR1_CSC);
    eval 'sub SAB82532_IMR1_XON () {0x2;}' unless defined(&SAB82532_IMR1_XON);
    eval 'sub SAB82532_IMR1_XPR () {0x1;}' unless defined(&SAB82532_IMR1_XPR);
    eval 'sub SAB82532_PIS_SYNC_B () {0x8;}' unless defined(&SAB82532_PIS_SYNC_B);
    eval 'sub SAB82532_PIS_DTR_B () {0x4;}' unless defined(&SAB82532_PIS_DTR_B);
    eval 'sub SAB82532_PIS_DTR_A () {0x2;}' unless defined(&SAB82532_PIS_DTR_A);
    eval 'sub SAB82532_PIS_SYNC_A () {0x1;}' unless defined(&SAB82532_PIS_SYNC_A);
    eval 'sub SAB82532_CCR4_MCK4 () {0x80;}' unless defined(&SAB82532_CCR4_MCK4);
    eval 'sub SAB82532_CCR4_EBRG () {0x40;}' unless defined(&SAB82532_CCR4_EBRG);
    eval 'sub SAB82532_CCR4_TST1 () {0x20;}' unless defined(&SAB82532_CCR4_TST1);
    eval 'sub SAB82532_CCR4_ICD () {0x10;}' unless defined(&SAB82532_CCR4_ICD);
}
1;
