require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_MATH_H)) {
    die("Never use <bits/huge_val.h> directly; include <math.h> instead.");
}
require 'features.ph';
require 'bits/wordsize.ph';
if(defined(&__GNUC__)) {
    if( &__GNUC_PREREQ(2,96)) {
	eval 'sub HUGE_VAL () {( &__extension__ 0x1.0 &p2047);}' unless defined(&HUGE_VAL);
    } else {
	eval 'sub HUGE_VAL () {( &__extension__ ((\'union union\' {  &unsigned __l __attribute__(( &__mode__( &__DI__)));  &double  &__d; }) {  &__l: 9.21886843722741e+18 }). &__d);}' unless defined(&HUGE_VAL);
    }
} else {
    eval 'sub __HUGE_VAL_bytes () {{ 0x7f, 0xf0, 0, 0, 0, 0, 0, 0};}' unless defined(&__HUGE_VAL_bytes);
    eval 'sub HUGE_VAL () {( ($__huge_val->{__d}));}' unless defined(&HUGE_VAL);
}
if(defined(&__USE_ISOC99)) {
    if( &__GNUC_PREREQ(2,96)) {
	eval 'sub HUGE_VALF () {( &__extension__ 0x1.0 &p255f);}' unless defined(&HUGE_VALF);
	if((defined(&__WORDSIZE) ? &__WORDSIZE : 0) == 32) {
	    eval 'sub HUGE_VALL () { &HUGE_VAL;}' unless defined(&HUGE_VALL);
	} else {
	    eval 'sub HUGE_VALL () {( &__extension__ 0x1.0 &p32767L);}' unless defined(&HUGE_VALL);
	}
    } else {
	if(defined(&__GNUC__)) {
	    eval 'sub HUGE_VALF () {( &__extension__ ((\'union union\' {  &unsigned __l __attribute__(( &__mode__( &__SI__)));  &float  &__d; }) {  &__l: 0x7f800000 }). &__d);}' unless defined(&HUGE_VALF);
	} else {
	    eval 'sub __HUGE_VALF_bytes () {{ 0x7f, 0x80, 0, 0};}' unless defined(&__HUGE_VALF_bytes);
	    eval 'sub HUGE_VALF () {( ($__huge_valf->{__f}));}' unless defined(&HUGE_VALF);
	}
	if((defined(&__WORDSIZE) ? &__WORDSIZE : 0) == 32) {
	    eval 'sub HUGE_VALL () { &HUGE_VAL;}' unless defined(&HUGE_VALL);
	} else {
	    if(defined(&__GNUC__)) {
		eval 'sub HUGE_VALL () {( &__extension__ ((\'union union\' { \'struct struct\' { \'unsigned long __h\',  &__l; }  &__i; \'long double __d\'; }) {  &__i: {  &__h: 9.22309056187807e+18,  &__l: 0} }). &__d);}' unless defined(&HUGE_VALL);
	    } else {
		eval 'sub __HUGE_VALL_bytes () {{ 0x7f, 0xff, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};}' unless defined(&__HUGE_VALL_bytes);
		eval 'sub HUGE_VALL () {( ($__huge_vall->{__d}));}' unless defined(&HUGE_VALL);
	    }
	}
    }
}
1;
