require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&AUTOCONF_INCLUDED)) {
    sub AUTOCONF_INCLUDED () {	1;}
}
unless(defined(&CONFIG_EXPERIMENTAL)) {
    sub CONFIG_EXPERIMENTAL () {	1;}
}
unless(defined(&CONFIG_MODULES)) {
    sub CONFIG_MODULES () {	1;}
}
unless(defined(&CONFIG_MODVERSIONS)) {
    sub CONFIG_MODVERSIONS () {	1;}
}
unless(defined(&CONFIG_KMOD)) {
    sub CONFIG_KMOD () {	1;}
}
undef(&CONFIG_BBC_I2C) if defined(&CONFIG_BBC_I2C);
unless(defined(&CONFIG_BBC_I2C_MODULE)) {
    sub CONFIG_BBC_I2C_MODULE () {	1;}
}
unless(defined(&CONFIG_VT)) {
    sub CONFIG_VT () {	1;}
}
unless(defined(&CONFIG_VT_CONSOLE)) {
    sub CONFIG_VT_CONSOLE () {	1;}
}
unless(defined(&CONFIG_SMP)) {
    sub CONFIG_SMP () {	1;}
}
unless(defined(&CONFIG_NR_CPUS)) {
    sub CONFIG_NR_CPUS () {	(32);}
}
unless(defined(&CONFIG_SPARC64)) {
    sub CONFIG_SPARC64 () {	1;}
}
unless(defined(&CONFIG_HOTPLUG)) {
    sub CONFIG_HOTPLUG () {	1;}
}
unless(defined(&CONFIG_HAVE_DEC_LOCK)) {
    sub CONFIG_HAVE_DEC_LOCK () {	1;}
}
undef(&CONFIG_RWSEM_GENERIC_SPINLOCK) if defined(&CONFIG_RWSEM_GENERIC_SPINLOCK);
unless(defined(&CONFIG_RWSEM_XCHGADD_ALGORITHM)) {
    sub CONFIG_RWSEM_XCHGADD_ALGORITHM () {	1;}
}
undef(&CONFIG_ISA) if defined(&CONFIG_ISA);
undef(&CONFIG_ISAPNP) if defined(&CONFIG_ISAPNP);
undef(&CONFIG_EISA) if defined(&CONFIG_EISA);
undef(&CONFIG_MCA) if defined(&CONFIG_MCA);
undef(&CONFIG_PCMCIA) if defined(&CONFIG_PCMCIA);
unless(defined(&CONFIG_SBUS)) {
    sub CONFIG_SBUS () {	1;}
}
unless(defined(&CONFIG_SBUSCHAR)) {
    sub CONFIG_SBUSCHAR () {	1;}
}
unless(defined(&CONFIG_BUSMOUSE)) {
    sub CONFIG_BUSMOUSE () {	1;}
}
unless(defined(&CONFIG_SUN_MOUSE)) {
    sub CONFIG_SUN_MOUSE () {	1;}
}
unless(defined(&CONFIG_SERIAL)) {
    sub CONFIG_SERIAL () {	1;}
}
unless(defined(&CONFIG_SUN_SERIAL)) {
    sub CONFIG_SUN_SERIAL () {	1;}
}
unless(defined(&CONFIG_SERIAL_CONSOLE)) {
    sub CONFIG_SERIAL_CONSOLE () {	1;}
}
unless(defined(&CONFIG_SUN_KEYBOARD)) {
    sub CONFIG_SUN_KEYBOARD () {	1;}
}
unless(defined(&CONFIG_SUN_CONSOLE)) {
    sub CONFIG_SUN_CONSOLE () {	1;}
}
unless(defined(&CONFIG_SUN_AUXIO)) {
    sub CONFIG_SUN_AUXIO () {	1;}
}
unless(defined(&CONFIG_SUN_IO)) {
    sub CONFIG_SUN_IO () {	1;}
}
unless(defined(&CONFIG_PCI)) {
    sub CONFIG_PCI () {	1;}
}
unless(defined(&CONFIG_RTC)) {
    sub CONFIG_RTC () {	1;}
}
undef(&CONFIG_PCI_NAMES) if defined(&CONFIG_PCI_NAMES);
undef(&CONFIG_SUN_OPENPROMFS) if defined(&CONFIG_SUN_OPENPROMFS);
unless(defined(&CONFIG_SUN_OPENPROMFS_MODULE)) {
    sub CONFIG_SUN_OPENPROMFS_MODULE () {	1;}
}
unless(defined(&CONFIG_NET)) {
    sub CONFIG_NET () {	1;}
}
unless(defined(&CONFIG_SYSVIPC)) {
    sub CONFIG_SYSVIPC () {	1;}
}
undef(&CONFIG_BSD_PROCESS_ACCT) if defined(&CONFIG_BSD_PROCESS_ACCT);
unless(defined(&CONFIG_SYSCTL)) {
    sub CONFIG_SYSCTL () {	1;}
}
unless(defined(&CONFIG_KCORE_ELF)) {
    sub CONFIG_KCORE_ELF () {	1;}
}
unless(defined(&CONFIG_SPARC32_COMPAT)) {
    sub CONFIG_SPARC32_COMPAT () {	1;}
}
unless(defined(&CONFIG_BINFMT_ELF32)) {
    sub CONFIG_BINFMT_ELF32 () {	1;}
}
undef(&CONFIG_BINFMT_AOUT32) if defined(&CONFIG_BINFMT_AOUT32);
unless(defined(&CONFIG_BINFMT_ELF)) {
    sub CONFIG_BINFMT_ELF () {	1;}
}
undef(&CONFIG_BINFMT_MISC) if defined(&CONFIG_BINFMT_MISC);
unless(defined(&CONFIG_BINFMT_MISC_MODULE)) {
    sub CONFIG_BINFMT_MISC_MODULE () {	1;}
}
undef(&CONFIG_SUNOS_EMUL) if defined(&CONFIG_SUNOS_EMUL);
undef(&CONFIG_SOLARIS_EMUL) if defined(&CONFIG_SOLARIS_EMUL);
unless(defined(&CONFIG_SOLARIS_EMUL_MODULE)) {
    sub CONFIG_SOLARIS_EMUL_MODULE () {	1;}
}
undef(&CONFIG_PARPORT) if defined(&CONFIG_PARPORT);
unless(defined(&CONFIG_PARPORT_MODULE)) {
    sub CONFIG_PARPORT_MODULE () {	1;}
}
undef(&CONFIG_PARPORT_PC) if defined(&CONFIG_PARPORT_PC);
unless(defined(&CONFIG_PARPORT_PC_MODULE)) {
    sub CONFIG_PARPORT_PC_MODULE () {	1;}
}
undef(&CONFIG_PARPORT_PC_CML1) if defined(&CONFIG_PARPORT_PC_CML1);
unless(defined(&CONFIG_PARPORT_PC_CML1_MODULE)) {
    sub CONFIG_PARPORT_PC_CML1_MODULE () {	1;}
}
undef(&CONFIG_PARPORT_SERIAL) if defined(&CONFIG_PARPORT_SERIAL);
unless(defined(&CONFIG_PARPORT_PC_FIFO)) {
    sub CONFIG_PARPORT_PC_FIFO () {	1;}
}
undef(&CONFIG_PARPORT_PC_SUPERIO) if defined(&CONFIG_PARPORT_PC_SUPERIO);
undef(&CONFIG_PARPORT_AMIGA) if defined(&CONFIG_PARPORT_AMIGA);
undef(&CONFIG_PARPORT_MFC3) if defined(&CONFIG_PARPORT_MFC3);
undef(&CONFIG_PARPORT_ATARI) if defined(&CONFIG_PARPORT_ATARI);
undef(&CONFIG_PARPORT_GSC) if defined(&CONFIG_PARPORT_GSC);
undef(&CONFIG_PARPORT_SUNBPP) if defined(&CONFIG_PARPORT_SUNBPP);
undef(&CONFIG_PARPORT_OTHER) if defined(&CONFIG_PARPORT_OTHER);
unless(defined(&CONFIG_PARPORT_1284)) {
    sub CONFIG_PARPORT_1284 () {	1;}
}
undef(&CONFIG_PRINTER) if defined(&CONFIG_PRINTER);
unless(defined(&CONFIG_PRINTER_MODULE)) {
    sub CONFIG_PRINTER_MODULE () {	1;}
}
undef(&CONFIG_ENVCTRL) if defined(&CONFIG_ENVCTRL);
unless(defined(&CONFIG_ENVCTRL_MODULE)) {
    sub CONFIG_ENVCTRL_MODULE () {	1;}
}
undef(&CONFIG_DISPLAY7SEG) if defined(&CONFIG_DISPLAY7SEG);
unless(defined(&CONFIG_DISPLAY7SEG_MODULE)) {
    sub CONFIG_DISPLAY7SEG_MODULE () {	1;}
}
undef(&CONFIG_WATCHDOG_CP1XXX) if defined(&CONFIG_WATCHDOG_CP1XXX);
unless(defined(&CONFIG_WATCHDOG_CP1XXX_MODULE)) {
    sub CONFIG_WATCHDOG_CP1XXX_MODULE () {	1;}
}
undef(&CONFIG_WATCHDOG_RIO) if defined(&CONFIG_WATCHDOG_RIO);
unless(defined(&CONFIG_WATCHDOG_RIO_MODULE)) {
    sub CONFIG_WATCHDOG_RIO_MODULE () {	1;}
}
unless(defined(&CONFIG_PROM_CONSOLE)) {
    sub CONFIG_PROM_CONSOLE () {	1;}
}
unless(defined(&CONFIG_FB)) {
    sub CONFIG_FB () {	1;}
}
unless(defined(&CONFIG_DUMMY_CONSOLE)) {
    sub CONFIG_DUMMY_CONSOLE () {	1;}
}
undef(&CONFIG_FB_RIVA) if defined(&CONFIG_FB_RIVA);
undef(&CONFIG_FB_CLGEN) if defined(&CONFIG_FB_CLGEN);
unless(defined(&CONFIG_FB_PM2)) {
    sub CONFIG_FB_PM2 () {	1;}
}
undef(&CONFIG_FB_PM2_FIFO_DISCONNECT) if defined(&CONFIG_FB_PM2_FIFO_DISCONNECT);
unless(defined(&CONFIG_FB_PM2_PCI)) {
    sub CONFIG_FB_PM2_PCI () {	1;}
}
undef(&CONFIG_FB_PM3) if defined(&CONFIG_FB_PM3);
undef(&CONFIG_FB_CYBER2000) if defined(&CONFIG_FB_CYBER2000);
undef(&CONFIG_FB_MATROX) if defined(&CONFIG_FB_MATROX);
unless(defined(&CONFIG_FB_ATY)) {
    sub CONFIG_FB_ATY () {	1;}
}
undef(&CONFIG_FB_ATY_GX) if defined(&CONFIG_FB_ATY_GX);
unless(defined(&CONFIG_FB_ATY_CT)) {
    sub CONFIG_FB_ATY_CT () {	1;}
}
undef(&CONFIG_FB_RADEON) if defined(&CONFIG_FB_RADEON);
undef(&CONFIG_FB_ATY128) if defined(&CONFIG_FB_ATY128);
undef(&CONFIG_FB_INTEL) if defined(&CONFIG_FB_INTEL);
undef(&CONFIG_FB_SIS) if defined(&CONFIG_FB_SIS);
undef(&CONFIG_FB_NEOMAGIC) if defined(&CONFIG_FB_NEOMAGIC);
undef(&CONFIG_FB_3DFX) if defined(&CONFIG_FB_3DFX);
undef(&CONFIG_FB_VOODOO1) if defined(&CONFIG_FB_VOODOO1);
undef(&CONFIG_FB_TRIDENT) if defined(&CONFIG_FB_TRIDENT);
unless(defined(&CONFIG_FB_SBUS)) {
    sub CONFIG_FB_SBUS () {	1;}
}
unless(defined(&CONFIG_FB_CREATOR)) {
    sub CONFIG_FB_CREATOR () {	1;}
}
unless(defined(&CONFIG_FB_CGSIX)) {
    sub CONFIG_FB_CGSIX () {	1;}
}
undef(&CONFIG_FB_BWTWO) if defined(&CONFIG_FB_BWTWO);
undef(&CONFIG_FB_CGTHREE) if defined(&CONFIG_FB_CGTHREE);
undef(&CONFIG_FB_LEO) if defined(&CONFIG_FB_LEO);
unless(defined(&CONFIG_FB_PCI)) {
    sub CONFIG_FB_PCI () {	1;}
}
unless(defined(&CONFIG_FB_ATY)) {
    sub CONFIG_FB_ATY () {	1;}
}
unless(defined(&CONFIG_FB_ATY_CT)) {
    sub CONFIG_FB_ATY_CT () {	1;}
}
undef(&CONFIG_FB_VIRTUAL) if defined(&CONFIG_FB_VIRTUAL);
undef(&CONFIG_FBCON_ADVANCED) if defined(&CONFIG_FBCON_ADVANCED);
unless(defined(&CONFIG_FBCON_CFB8)) {
    sub CONFIG_FBCON_CFB8 () {	1;}
}
unless(defined(&CONFIG_FBCON_CFB16)) {
    sub CONFIG_FBCON_CFB16 () {	1;}
}
unless(defined(&CONFIG_FBCON_CFB24)) {
    sub CONFIG_FBCON_CFB24 () {	1;}
}
unless(defined(&CONFIG_FBCON_CFB32)) {
    sub CONFIG_FBCON_CFB32 () {	1;}
}
unless(defined(&CONFIG_FBCON_FONTWIDTH8_ONLY)) {
    sub CONFIG_FBCON_FONTWIDTH8_ONLY () {	1;}
}
unless(defined(&CONFIG_FONT_SUN8x16)) {
    sub CONFIG_FONT_SUN8x16 () {	1;}
}
undef(&CONFIG_FBCON_FONTS) if defined(&CONFIG_FBCON_FONTS);
undef(&CONFIG_SUN_OPENPROMIO) if defined(&CONFIG_SUN_OPENPROMIO);
unless(defined(&CONFIG_SUN_OPENPROMIO_MODULE)) {
    sub CONFIG_SUN_OPENPROMIO_MODULE () {	1;}
}
unless(defined(&CONFIG_SUN_MOSTEK_RTC)) {
    sub CONFIG_SUN_MOSTEK_RTC () {	1;}
}
unless(defined(&CONFIG_SAB82532)) {
    sub CONFIG_SAB82532 () {	1;}
}
undef(&CONFIG_OBP_FLASH) if defined(&CONFIG_OBP_FLASH);
unless(defined(&CONFIG_OBP_FLASH_MODULE)) {
    sub CONFIG_OBP_FLASH_MODULE () {	1;}
}
undef(&CONFIG_SUN_BPP) if defined(&CONFIG_SUN_BPP);
undef(&CONFIG_SUN_VIDEOPIX) if defined(&CONFIG_SUN_VIDEOPIX);
undef(&CONFIG_SUN_AURORA) if defined(&CONFIG_SUN_AURORA);
unless(defined(&CONFIG_SUN_AURORA_MODULE)) {
    sub CONFIG_SUN_AURORA_MODULE () {	1;}
}
undef(&CONFIG_SPARCAUDIO) if defined(&CONFIG_SPARCAUDIO);
unless(defined(&CONFIG_SPARCAUDIO_MODULE)) {
    sub CONFIG_SPARCAUDIO_MODULE () {	1;}
}
undef(&CONFIG_SPARCAUDIO_CS4231) if defined(&CONFIG_SPARCAUDIO_CS4231);
unless(defined(&CONFIG_SPARCAUDIO_CS4231_MODULE)) {
    sub CONFIG_SPARCAUDIO_CS4231_MODULE () {	1;}
}
undef(&CONFIG_SPARCAUDIO_DUMMY) if defined(&CONFIG_SPARCAUDIO_DUMMY);
undef(&CONFIG_MTD) if defined(&CONFIG_MTD);
unless(defined(&CONFIG_BLK_DEV_FD)) {
    sub CONFIG_BLK_DEV_FD () {	1;}
}
undef(&CONFIG_BLK_DEV_LOOP) if defined(&CONFIG_BLK_DEV_LOOP);
unless(defined(&CONFIG_BLK_DEV_LOOP_MODULE)) {
    sub CONFIG_BLK_DEV_LOOP_MODULE () {	1;}
}
undef(&CONFIG_BLK_DEV_NBD) if defined(&CONFIG_BLK_DEV_NBD);
unless(defined(&CONFIG_BLK_DEV_NBD_MODULE)) {
    sub CONFIG_BLK_DEV_NBD_MODULE () {	1;}
}
unless(defined(&CONFIG_MD)) {
    sub CONFIG_MD () {	1;}
}
undef(&CONFIG_BLK_DEV_MD) if defined(&CONFIG_BLK_DEV_MD);
unless(defined(&CONFIG_BLK_DEV_MD_MODULE)) {
    sub CONFIG_BLK_DEV_MD_MODULE () {	1;}
}
undef(&CONFIG_MD_LINEAR) if defined(&CONFIG_MD_LINEAR);
unless(defined(&CONFIG_MD_LINEAR_MODULE)) {
    sub CONFIG_MD_LINEAR_MODULE () {	1;}
}
undef(&CONFIG_MD_RAID0) if defined(&CONFIG_MD_RAID0);
unless(defined(&CONFIG_MD_RAID0_MODULE)) {
    sub CONFIG_MD_RAID0_MODULE () {	1;}
}
undef(&CONFIG_MD_RAID1) if defined(&CONFIG_MD_RAID1);
unless(defined(&CONFIG_MD_RAID1_MODULE)) {
    sub CONFIG_MD_RAID1_MODULE () {	1;}
}
undef(&CONFIG_MD_RAID5) if defined(&CONFIG_MD_RAID5);
unless(defined(&CONFIG_MD_RAID5_MODULE)) {
    sub CONFIG_MD_RAID5_MODULE () {	1;}
}
undef(&CONFIG_MD_MULTIPATH) if defined(&CONFIG_MD_MULTIPATH);
unless(defined(&CONFIG_MD_MULTIPATH_MODULE)) {
    sub CONFIG_MD_MULTIPATH_MODULE () {	1;}
}
undef(&CONFIG_BLK_DEV_LVM) if defined(&CONFIG_BLK_DEV_LVM);
unless(defined(&CONFIG_BLK_DEV_LVM_MODULE)) {
    sub CONFIG_BLK_DEV_LVM_MODULE () {	1;}
}
undef(&CONFIG_BLK_DEV_RAM) if defined(&CONFIG_BLK_DEV_RAM);
unless(defined(&CONFIG_BLK_DEV_RAM_MODULE)) {
    sub CONFIG_BLK_DEV_RAM_MODULE () {	1;}
}
unless(defined(&CONFIG_BLK_DEV_RAM_SIZE)) {
    sub CONFIG_BLK_DEV_RAM_SIZE () {	(4096);}
}
undef(&CONFIG_BLK_DEV_INITRD) if defined(&CONFIG_BLK_DEV_INITRD);
unless(defined(&CONFIG_PACKET)) {
    sub CONFIG_PACKET () {	1;}
}
unless(defined(&CONFIG_PACKET_MMAP)) {
    sub CONFIG_PACKET_MMAP () {	1;}
}
unless(defined(&CONFIG_NETLINK_DEV)) {
    sub CONFIG_NETLINK_DEV () {	1;}
}
unless(defined(&CONFIG_NETFILTER)) {
    sub CONFIG_NETFILTER () {	1;}
}
undef(&CONFIG_NETFILTER_DEBUG) if defined(&CONFIG_NETFILTER_DEBUG);
unless(defined(&CONFIG_FILTER)) {
    sub CONFIG_FILTER () {	1;}
}
unless(defined(&CONFIG_UNIX)) {
    sub CONFIG_UNIX () {	1;}
}
unless(defined(&CONFIG_INET)) {
    sub CONFIG_INET () {	1;}
}
unless(defined(&CONFIG_IP_MULTICAST)) {
    sub CONFIG_IP_MULTICAST () {	1;}
}
undef(&CONFIG_IP_ADVANCED_ROUTER) if defined(&CONFIG_IP_ADVANCED_ROUTER);
undef(&CONFIG_IP_PNP) if defined(&CONFIG_IP_PNP);
undef(&CONFIG_NET_IPIP) if defined(&CONFIG_NET_IPIP);
unless(defined(&CONFIG_NET_IPIP_MODULE)) {
    sub CONFIG_NET_IPIP_MODULE () {	1;}
}
undef(&CONFIG_NET_IPGRE) if defined(&CONFIG_NET_IPGRE);
unless(defined(&CONFIG_NET_IPGRE_MODULE)) {
    sub CONFIG_NET_IPGRE_MODULE () {	1;}
}
unless(defined(&CONFIG_NET_IPGRE_BROADCAST)) {
    sub CONFIG_NET_IPGRE_BROADCAST () {	1;}
}
unless(defined(&CONFIG_IP_MROUTE)) {
    sub CONFIG_IP_MROUTE () {	1;}
}
unless(defined(&CONFIG_IP_PIMSM_V1)) {
    sub CONFIG_IP_PIMSM_V1 () {	1;}
}
unless(defined(&CONFIG_IP_PIMSM_V2)) {
    sub CONFIG_IP_PIMSM_V2 () {	1;}
}
unless(defined(&CONFIG_ARPD)) {
    sub CONFIG_ARPD () {	1;}
}
unless(defined(&CONFIG_INET_ECN)) {
    sub CONFIG_INET_ECN () {	1;}
}
undef(&CONFIG_SYN_COOKIES) if defined(&CONFIG_SYN_COOKIES);
undef(&CONFIG_IP_NF_CONNTRACK) if defined(&CONFIG_IP_NF_CONNTRACK);
unless(defined(&CONFIG_IP_NF_CONNTRACK_MODULE)) {
    sub CONFIG_IP_NF_CONNTRACK_MODULE () {	1;}
}
undef(&CONFIG_IP_NF_FTP) if defined(&CONFIG_IP_NF_FTP);
unless(defined(&CONFIG_IP_NF_FTP_MODULE)) {
    sub CONFIG_IP_NF_FTP_MODULE () {	1;}
}
undef(&CONFIG_IP_NF_AMANDA) if defined(&CONFIG_IP_NF_AMANDA);
unless(defined(&CONFIG_IP_NF_AMANDA_MODULE)) {
    sub CONFIG_IP_NF_AMANDA_MODULE () {	1;}
}
undef(&CONFIG_IP_NF_TFTP) if defined(&CONFIG_IP_NF_TFTP);
unless(defined(&CONFIG_IP_NF_TFTP_MODULE)) {
    sub CONFIG_IP_NF_TFTP_MODULE () {	1;}
}
undef(&CONFIG_IP_NF_IRC) if defined(&CONFIG_IP_NF_IRC);
unless(defined(&CONFIG_IP_NF_IRC_MODULE)) {
    sub CONFIG_IP_NF_IRC_MODULE () {	1;}
}
undef(&CONFIG_IP_NF_QUEUE) if defined(&CONFIG_IP_NF_QUEUE);
unless(defined(&CONFIG_IP_NF_QUEUE_MODULE)) {
    sub CONFIG_IP_NF_QUEUE_MODULE () {	1;}
}
undef(&CONFIG_IP_NF_IPTABLES) if defined(&CONFIG_IP_NF_IPTABLES);
unless(defined(&CONFIG_IP_NF_IPTABLES_MODULE)) {
    sub CONFIG_IP_NF_IPTABLES_MODULE () {	1;}
}
undef(&CONFIG_IP_NF_MATCH_LIMIT) if defined(&CONFIG_IP_NF_MATCH_LIMIT);
unless(defined(&CONFIG_IP_NF_MATCH_LIMIT_MODULE)) {
    sub CONFIG_IP_NF_MATCH_LIMIT_MODULE () {	1;}
}
undef(&CONFIG_IP_NF_MATCH_MAC) if defined(&CONFIG_IP_NF_MATCH_MAC);
unless(defined(&CONFIG_IP_NF_MATCH_MAC_MODULE)) {
    sub CONFIG_IP_NF_MATCH_MAC_MODULE () {	1;}
}
undef(&CONFIG_IP_NF_MATCH_PKTTYPE) if defined(&CONFIG_IP_NF_MATCH_PKTTYPE);
unless(defined(&CONFIG_IP_NF_MATCH_PKTTYPE_MODULE)) {
    sub CONFIG_IP_NF_MATCH_PKTTYPE_MODULE () {	1;}
}
undef(&CONFIG_IP_NF_MATCH_MARK) if defined(&CONFIG_IP_NF_MATCH_MARK);
unless(defined(&CONFIG_IP_NF_MATCH_MARK_MODULE)) {
    sub CONFIG_IP_NF_MATCH_MARK_MODULE () {	1;}
}
undef(&CONFIG_IP_NF_MATCH_MULTIPORT) if defined(&CONFIG_IP_NF_MATCH_MULTIPORT);
unless(defined(&CONFIG_IP_NF_MATCH_MULTIPORT_MODULE)) {
    sub CONFIG_IP_NF_MATCH_MULTIPORT_MODULE () {	1;}
}
undef(&CONFIG_IP_NF_MATCH_TOS) if defined(&CONFIG_IP_NF_MATCH_TOS);
unless(defined(&CONFIG_IP_NF_MATCH_TOS_MODULE)) {
    sub CONFIG_IP_NF_MATCH_TOS_MODULE () {	1;}
}
undef(&CONFIG_IP_NF_MATCH_RECENT) if defined(&CONFIG_IP_NF_MATCH_RECENT);
unless(defined(&CONFIG_IP_NF_MATCH_RECENT_MODULE)) {
    sub CONFIG_IP_NF_MATCH_RECENT_MODULE () {	1;}
}
undef(&CONFIG_IP_NF_MATCH_ECN) if defined(&CONFIG_IP_NF_MATCH_ECN);
unless(defined(&CONFIG_IP_NF_MATCH_ECN_MODULE)) {
    sub CONFIG_IP_NF_MATCH_ECN_MODULE () {	1;}
}
undef(&CONFIG_IP_NF_MATCH_DSCP) if defined(&CONFIG_IP_NF_MATCH_DSCP);
unless(defined(&CONFIG_IP_NF_MATCH_DSCP_MODULE)) {
    sub CONFIG_IP_NF_MATCH_DSCP_MODULE () {	1;}
}
undef(&CONFIG_IP_NF_MATCH_AH_ESP) if defined(&CONFIG_IP_NF_MATCH_AH_ESP);
unless(defined(&CONFIG_IP_NF_MATCH_AH_ESP_MODULE)) {
    sub CONFIG_IP_NF_MATCH_AH_ESP_MODULE () {	1;}
}
undef(&CONFIG_IP_NF_MATCH_LENGTH) if defined(&CONFIG_IP_NF_MATCH_LENGTH);
unless(defined(&CONFIG_IP_NF_MATCH_LENGTH_MODULE)) {
    sub CONFIG_IP_NF_MATCH_LENGTH_MODULE () {	1;}
}
undef(&CONFIG_IP_NF_MATCH_TTL) if defined(&CONFIG_IP_NF_MATCH_TTL);
unless(defined(&CONFIG_IP_NF_MATCH_TTL_MODULE)) {
    sub CONFIG_IP_NF_MATCH_TTL_MODULE () {	1;}
}
undef(&CONFIG_IP_NF_MATCH_TCPMSS) if defined(&CONFIG_IP_NF_MATCH_TCPMSS);
unless(defined(&CONFIG_IP_NF_MATCH_TCPMSS_MODULE)) {
    sub CONFIG_IP_NF_MATCH_TCPMSS_MODULE () {	1;}
}
undef(&CONFIG_IP_NF_MATCH_HELPER) if defined(&CONFIG_IP_NF_MATCH_HELPER);
unless(defined(&CONFIG_IP_NF_MATCH_HELPER_MODULE)) {
    sub CONFIG_IP_NF_MATCH_HELPER_MODULE () {	1;}
}
undef(&CONFIG_IP_NF_MATCH_STATE) if defined(&CONFIG_IP_NF_MATCH_STATE);
unless(defined(&CONFIG_IP_NF_MATCH_STATE_MODULE)) {
    sub CONFIG_IP_NF_MATCH_STATE_MODULE () {	1;}
}
undef(&CONFIG_IP_NF_MATCH_CONNTRACK) if defined(&CONFIG_IP_NF_MATCH_CONNTRACK);
unless(defined(&CONFIG_IP_NF_MATCH_CONNTRACK_MODULE)) {
    sub CONFIG_IP_NF_MATCH_CONNTRACK_MODULE () {	1;}
}
undef(&CONFIG_IP_NF_MATCH_UNCLEAN) if defined(&CONFIG_IP_NF_MATCH_UNCLEAN);
unless(defined(&CONFIG_IP_NF_MATCH_UNCLEAN_MODULE)) {
    sub CONFIG_IP_NF_MATCH_UNCLEAN_MODULE () {	1;}
}
undef(&CONFIG_IP_NF_MATCH_OWNER) if defined(&CONFIG_IP_NF_MATCH_OWNER);
unless(defined(&CONFIG_IP_NF_MATCH_OWNER_MODULE)) {
    sub CONFIG_IP_NF_MATCH_OWNER_MODULE () {	1;}
}
undef(&CONFIG_IP_NF_FILTER) if defined(&CONFIG_IP_NF_FILTER);
unless(defined(&CONFIG_IP_NF_FILTER_MODULE)) {
    sub CONFIG_IP_NF_FILTER_MODULE () {	1;}
}
undef(&CONFIG_IP_NF_TARGET_REJECT) if defined(&CONFIG_IP_NF_TARGET_REJECT);
unless(defined(&CONFIG_IP_NF_TARGET_REJECT_MODULE)) {
    sub CONFIG_IP_NF_TARGET_REJECT_MODULE () {	1;}
}
undef(&CONFIG_IP_NF_TARGET_MIRROR) if defined(&CONFIG_IP_NF_TARGET_MIRROR);
unless(defined(&CONFIG_IP_NF_TARGET_MIRROR_MODULE)) {
    sub CONFIG_IP_NF_TARGET_MIRROR_MODULE () {	1;}
}
undef(&CONFIG_IP_NF_NAT) if defined(&CONFIG_IP_NF_NAT);
unless(defined(&CONFIG_IP_NF_NAT_MODULE)) {
    sub CONFIG_IP_NF_NAT_MODULE () {	1;}
}
unless(defined(&CONFIG_IP_NF_NAT_NEEDED)) {
    sub CONFIG_IP_NF_NAT_NEEDED () {	1;}
}
undef(&CONFIG_IP_NF_TARGET_MASQUERADE) if defined(&CONFIG_IP_NF_TARGET_MASQUERADE);
unless(defined(&CONFIG_IP_NF_TARGET_MASQUERADE_MODULE)) {
    sub CONFIG_IP_NF_TARGET_MASQUERADE_MODULE () {	1;}
}
undef(&CONFIG_IP_NF_TARGET_REDIRECT) if defined(&CONFIG_IP_NF_TARGET_REDIRECT);
unless(defined(&CONFIG_IP_NF_TARGET_REDIRECT_MODULE)) {
    sub CONFIG_IP_NF_TARGET_REDIRECT_MODULE () {	1;}
}
undef(&CONFIG_IP_NF_NAT_AMANDA) if defined(&CONFIG_IP_NF_NAT_AMANDA);
unless(defined(&CONFIG_IP_NF_NAT_AMANDA_MODULE)) {
    sub CONFIG_IP_NF_NAT_AMANDA_MODULE () {	1;}
}
undef(&CONFIG_IP_NF_NAT_LOCAL) if defined(&CONFIG_IP_NF_NAT_LOCAL);
undef(&CONFIG_IP_NF_NAT_SNMP_BASIC) if defined(&CONFIG_IP_NF_NAT_SNMP_BASIC);
unless(defined(&CONFIG_IP_NF_NAT_SNMP_BASIC_MODULE)) {
    sub CONFIG_IP_NF_NAT_SNMP_BASIC_MODULE () {	1;}
}
undef(&CONFIG_IP_NF_NAT_IRC) if defined(&CONFIG_IP_NF_NAT_IRC);
unless(defined(&CONFIG_IP_NF_NAT_IRC_MODULE)) {
    sub CONFIG_IP_NF_NAT_IRC_MODULE () {	1;}
}
undef(&CONFIG_IP_NF_NAT_FTP) if defined(&CONFIG_IP_NF_NAT_FTP);
unless(defined(&CONFIG_IP_NF_NAT_FTP_MODULE)) {
    sub CONFIG_IP_NF_NAT_FTP_MODULE () {	1;}
}
undef(&CONFIG_IP_NF_NAT_TFTP) if defined(&CONFIG_IP_NF_NAT_TFTP);
unless(defined(&CONFIG_IP_NF_NAT_TFTP_MODULE)) {
    sub CONFIG_IP_NF_NAT_TFTP_MODULE () {	1;}
}
undef(&CONFIG_IP_NF_MANGLE) if defined(&CONFIG_IP_NF_MANGLE);
unless(defined(&CONFIG_IP_NF_MANGLE_MODULE)) {
    sub CONFIG_IP_NF_MANGLE_MODULE () {	1;}
}
undef(&CONFIG_IP_NF_TARGET_TOS) if defined(&CONFIG_IP_NF_TARGET_TOS);
unless(defined(&CONFIG_IP_NF_TARGET_TOS_MODULE)) {
    sub CONFIG_IP_NF_TARGET_TOS_MODULE () {	1;}
}
undef(&CONFIG_IP_NF_TARGET_ECN) if defined(&CONFIG_IP_NF_TARGET_ECN);
unless(defined(&CONFIG_IP_NF_TARGET_ECN_MODULE)) {
    sub CONFIG_IP_NF_TARGET_ECN_MODULE () {	1;}
}
undef(&CONFIG_IP_NF_TARGET_DSCP) if defined(&CONFIG_IP_NF_TARGET_DSCP);
unless(defined(&CONFIG_IP_NF_TARGET_DSCP_MODULE)) {
    sub CONFIG_IP_NF_TARGET_DSCP_MODULE () {	1;}
}
undef(&CONFIG_IP_NF_TARGET_MARK) if defined(&CONFIG_IP_NF_TARGET_MARK);
unless(defined(&CONFIG_IP_NF_TARGET_MARK_MODULE)) {
    sub CONFIG_IP_NF_TARGET_MARK_MODULE () {	1;}
}
undef(&CONFIG_IP_NF_TARGET_LOG) if defined(&CONFIG_IP_NF_TARGET_LOG);
unless(defined(&CONFIG_IP_NF_TARGET_LOG_MODULE)) {
    sub CONFIG_IP_NF_TARGET_LOG_MODULE () {	1;}
}
undef(&CONFIG_IP_NF_TARGET_ULOG) if defined(&CONFIG_IP_NF_TARGET_ULOG);
unless(defined(&CONFIG_IP_NF_TARGET_ULOG_MODULE)) {
    sub CONFIG_IP_NF_TARGET_ULOG_MODULE () {	1;}
}
undef(&CONFIG_IP_NF_TARGET_TCPMSS) if defined(&CONFIG_IP_NF_TARGET_TCPMSS);
unless(defined(&CONFIG_IP_NF_TARGET_TCPMSS_MODULE)) {
    sub CONFIG_IP_NF_TARGET_TCPMSS_MODULE () {	1;}
}
undef(&CONFIG_IP_NF_ARPTABLES) if defined(&CONFIG_IP_NF_ARPTABLES);
unless(defined(&CONFIG_IP_NF_ARPTABLES_MODULE)) {
    sub CONFIG_IP_NF_ARPTABLES_MODULE () {	1;}
}
undef(&CONFIG_IP_NF_ARPFILTER) if defined(&CONFIG_IP_NF_ARPFILTER);
unless(defined(&CONFIG_IP_NF_ARPFILTER_MODULE)) {
    sub CONFIG_IP_NF_ARPFILTER_MODULE () {	1;}
}
undef(&CONFIG_IP_NF_ARP_MANGLE) if defined(&CONFIG_IP_NF_ARP_MANGLE);
unless(defined(&CONFIG_IP_NF_ARP_MANGLE_MODULE)) {
    sub CONFIG_IP_NF_ARP_MANGLE_MODULE () {	1;}
}
undef(&CONFIG_IP_NF_COMPAT_IPCHAINS) if defined(&CONFIG_IP_NF_COMPAT_IPCHAINS);
unless(defined(&CONFIG_IP_NF_COMPAT_IPCHAINS_MODULE)) {
    sub CONFIG_IP_NF_COMPAT_IPCHAINS_MODULE () {	1;}
}
unless(defined(&CONFIG_IP_NF_NAT_NEEDED)) {
    sub CONFIG_IP_NF_NAT_NEEDED () {	1;}
}
undef(&CONFIG_IP_NF_COMPAT_IPFWADM) if defined(&CONFIG_IP_NF_COMPAT_IPFWADM);
unless(defined(&CONFIG_IP_NF_COMPAT_IPFWADM_MODULE)) {
    sub CONFIG_IP_NF_COMPAT_IPFWADM_MODULE () {	1;}
}
unless(defined(&CONFIG_IP_NF_NAT_NEEDED)) {
    sub CONFIG_IP_NF_NAT_NEEDED () {	1;}
}
undef(&CONFIG_IP_VS) if defined(&CONFIG_IP_VS);
unless(defined(&CONFIG_IP_VS_MODULE)) {
    sub CONFIG_IP_VS_MODULE () {	1;}
}
undef(&CONFIG_IP_VS_DEBUG) if defined(&CONFIG_IP_VS_DEBUG);
unless(defined(&CONFIG_IP_VS_TAB_BITS)) {
    sub CONFIG_IP_VS_TAB_BITS () {	(12);}
}
undef(&CONFIG_IP_VS_RR) if defined(&CONFIG_IP_VS_RR);
unless(defined(&CONFIG_IP_VS_RR_MODULE)) {
    sub CONFIG_IP_VS_RR_MODULE () {	1;}
}
undef(&CONFIG_IP_VS_WRR) if defined(&CONFIG_IP_VS_WRR);
unless(defined(&CONFIG_IP_VS_WRR_MODULE)) {
    sub CONFIG_IP_VS_WRR_MODULE () {	1;}
}
undef(&CONFIG_IP_VS_LC) if defined(&CONFIG_IP_VS_LC);
unless(defined(&CONFIG_IP_VS_LC_MODULE)) {
    sub CONFIG_IP_VS_LC_MODULE () {	1;}
}
undef(&CONFIG_IP_VS_WLC) if defined(&CONFIG_IP_VS_WLC);
unless(defined(&CONFIG_IP_VS_WLC_MODULE)) {
    sub CONFIG_IP_VS_WLC_MODULE () {	1;}
}
undef(&CONFIG_IP_VS_LBLC) if defined(&CONFIG_IP_VS_LBLC);
unless(defined(&CONFIG_IP_VS_LBLC_MODULE)) {
    sub CONFIG_IP_VS_LBLC_MODULE () {	1;}
}
undef(&CONFIG_IP_VS_LBLCR) if defined(&CONFIG_IP_VS_LBLCR);
unless(defined(&CONFIG_IP_VS_LBLCR_MODULE)) {
    sub CONFIG_IP_VS_LBLCR_MODULE () {	1;}
}
undef(&CONFIG_IP_VS_DH) if defined(&CONFIG_IP_VS_DH);
unless(defined(&CONFIG_IP_VS_DH_MODULE)) {
    sub CONFIG_IP_VS_DH_MODULE () {	1;}
}
undef(&CONFIG_IP_VS_SH) if defined(&CONFIG_IP_VS_SH);
unless(defined(&CONFIG_IP_VS_SH_MODULE)) {
    sub CONFIG_IP_VS_SH_MODULE () {	1;}
}
undef(&CONFIG_IP_VS_SED) if defined(&CONFIG_IP_VS_SED);
unless(defined(&CONFIG_IP_VS_SED_MODULE)) {
    sub CONFIG_IP_VS_SED_MODULE () {	1;}
}
undef(&CONFIG_IP_VS_NQ) if defined(&CONFIG_IP_VS_NQ);
unless(defined(&CONFIG_IP_VS_NQ_MODULE)) {
    sub CONFIG_IP_VS_NQ_MODULE () {	1;}
}
undef(&CONFIG_IP_VS_FTP) if defined(&CONFIG_IP_VS_FTP);
unless(defined(&CONFIG_IP_VS_FTP_MODULE)) {
    sub CONFIG_IP_VS_FTP_MODULE () {	1;}
}
undef(&CONFIG_IPV6) if defined(&CONFIG_IPV6);
unless(defined(&CONFIG_IPV6_MODULE)) {
    sub CONFIG_IPV6_MODULE () {	1;}
}
undef(&CONFIG_IP6_NF_QUEUE) if defined(&CONFIG_IP6_NF_QUEUE);
unless(defined(&CONFIG_IP6_NF_QUEUE_MODULE)) {
    sub CONFIG_IP6_NF_QUEUE_MODULE () {	1;}
}
undef(&CONFIG_IP6_NF_IPTABLES) if defined(&CONFIG_IP6_NF_IPTABLES);
unless(defined(&CONFIG_IP6_NF_IPTABLES_MODULE)) {
    sub CONFIG_IP6_NF_IPTABLES_MODULE () {	1;}
}
undef(&CONFIG_IP6_NF_MATCH_LIMIT) if defined(&CONFIG_IP6_NF_MATCH_LIMIT);
unless(defined(&CONFIG_IP6_NF_MATCH_LIMIT_MODULE)) {
    sub CONFIG_IP6_NF_MATCH_LIMIT_MODULE () {	1;}
}
undef(&CONFIG_IP6_NF_MATCH_MAC) if defined(&CONFIG_IP6_NF_MATCH_MAC);
unless(defined(&CONFIG_IP6_NF_MATCH_MAC_MODULE)) {
    sub CONFIG_IP6_NF_MATCH_MAC_MODULE () {	1;}
}
undef(&CONFIG_IP6_NF_MATCH_RT) if defined(&CONFIG_IP6_NF_MATCH_RT);
unless(defined(&CONFIG_IP6_NF_MATCH_RT_MODULE)) {
    sub CONFIG_IP6_NF_MATCH_RT_MODULE () {	1;}
}
undef(&CONFIG_IP6_NF_MATCH_OPTS) if defined(&CONFIG_IP6_NF_MATCH_OPTS);
unless(defined(&CONFIG_IP6_NF_MATCH_OPTS_MODULE)) {
    sub CONFIG_IP6_NF_MATCH_OPTS_MODULE () {	1;}
}
undef(&CONFIG_IP6_NF_MATCH_FRAG) if defined(&CONFIG_IP6_NF_MATCH_FRAG);
unless(defined(&CONFIG_IP6_NF_MATCH_FRAG_MODULE)) {
    sub CONFIG_IP6_NF_MATCH_FRAG_MODULE () {	1;}
}
undef(&CONFIG_IP6_NF_MATCH_HL) if defined(&CONFIG_IP6_NF_MATCH_HL);
unless(defined(&CONFIG_IP6_NF_MATCH_HL_MODULE)) {
    sub CONFIG_IP6_NF_MATCH_HL_MODULE () {	1;}
}
undef(&CONFIG_IP6_NF_MATCH_MULTIPORT) if defined(&CONFIG_IP6_NF_MATCH_MULTIPORT);
unless(defined(&CONFIG_IP6_NF_MATCH_MULTIPORT_MODULE)) {
    sub CONFIG_IP6_NF_MATCH_MULTIPORT_MODULE () {	1;}
}
undef(&CONFIG_IP6_NF_MATCH_OWNER) if defined(&CONFIG_IP6_NF_MATCH_OWNER);
unless(defined(&CONFIG_IP6_NF_MATCH_OWNER_MODULE)) {
    sub CONFIG_IP6_NF_MATCH_OWNER_MODULE () {	1;}
}
undef(&CONFIG_IP6_NF_MATCH_MARK) if defined(&CONFIG_IP6_NF_MATCH_MARK);
unless(defined(&CONFIG_IP6_NF_MATCH_MARK_MODULE)) {
    sub CONFIG_IP6_NF_MATCH_MARK_MODULE () {	1;}
}
undef(&CONFIG_IP6_NF_MATCH_IPV6HEADER) if defined(&CONFIG_IP6_NF_MATCH_IPV6HEADER);
unless(defined(&CONFIG_IP6_NF_MATCH_IPV6HEADER_MODULE)) {
    sub CONFIG_IP6_NF_MATCH_IPV6HEADER_MODULE () {	1;}
}
undef(&CONFIG_IP6_NF_MATCH_AHESP) if defined(&CONFIG_IP6_NF_MATCH_AHESP);
unless(defined(&CONFIG_IP6_NF_MATCH_AHESP_MODULE)) {
    sub CONFIG_IP6_NF_MATCH_AHESP_MODULE () {	1;}
}
undef(&CONFIG_IP6_NF_MATCH_LENGTH) if defined(&CONFIG_IP6_NF_MATCH_LENGTH);
unless(defined(&CONFIG_IP6_NF_MATCH_LENGTH_MODULE)) {
    sub CONFIG_IP6_NF_MATCH_LENGTH_MODULE () {	1;}
}
undef(&CONFIG_IP6_NF_MATCH_EUI64) if defined(&CONFIG_IP6_NF_MATCH_EUI64);
unless(defined(&CONFIG_IP6_NF_MATCH_EUI64_MODULE)) {
    sub CONFIG_IP6_NF_MATCH_EUI64_MODULE () {	1;}
}
undef(&CONFIG_IP6_NF_FILTER) if defined(&CONFIG_IP6_NF_FILTER);
unless(defined(&CONFIG_IP6_NF_FILTER_MODULE)) {
    sub CONFIG_IP6_NF_FILTER_MODULE () {	1;}
}
undef(&CONFIG_IP6_NF_TARGET_LOG) if defined(&CONFIG_IP6_NF_TARGET_LOG);
unless(defined(&CONFIG_IP6_NF_TARGET_LOG_MODULE)) {
    sub CONFIG_IP6_NF_TARGET_LOG_MODULE () {	1;}
}
undef(&CONFIG_IP6_NF_MANGLE) if defined(&CONFIG_IP6_NF_MANGLE);
unless(defined(&CONFIG_IP6_NF_MANGLE_MODULE)) {
    sub CONFIG_IP6_NF_MANGLE_MODULE () {	1;}
}
undef(&CONFIG_IP6_NF_TARGET_MARK) if defined(&CONFIG_IP6_NF_TARGET_MARK);
unless(defined(&CONFIG_IP6_NF_TARGET_MARK_MODULE)) {
    sub CONFIG_IP6_NF_TARGET_MARK_MODULE () {	1;}
}
undef(&CONFIG_KHTTPD) if defined(&CONFIG_KHTTPD);
undef(&CONFIG_IPV6_SCTP__) if defined(&CONFIG_IPV6_SCTP__);
unless(defined(&CONFIG_IPV6_SCTP___MODULE)) {
    sub CONFIG_IPV6_SCTP___MODULE () {	1;}
}
undef(&CONFIG_IP_SCTP) if defined(&CONFIG_IP_SCTP);
unless(defined(&CONFIG_IP_SCTP_MODULE)) {
    sub CONFIG_IP_SCTP_MODULE () {	1;}
}
undef(&CONFIG_SCTP_ADLER32) if defined(&CONFIG_SCTP_ADLER32);
undef(&CONFIG_SCTP_DBG_MSG) if defined(&CONFIG_SCTP_DBG_MSG);
undef(&CONFIG_SCTP_DBG_OBJCNT) if defined(&CONFIG_SCTP_DBG_OBJCNT);
undef(&CONFIG_ATM) if defined(&CONFIG_ATM);
undef(&CONFIG_VLAN_8021Q) if defined(&CONFIG_VLAN_8021Q);
unless(defined(&CONFIG_VLAN_8021Q_MODULE)) {
    sub CONFIG_VLAN_8021Q_MODULE () {	1;}
}
undef(&CONFIG_IPX) if defined(&CONFIG_IPX);
unless(defined(&CONFIG_IPX_MODULE)) {
    sub CONFIG_IPX_MODULE () {	1;}
}
undef(&CONFIG_IPX_INTERN) if defined(&CONFIG_IPX_INTERN);
undef(&CONFIG_ATALK) if defined(&CONFIG_ATALK);
unless(defined(&CONFIG_ATALK_MODULE)) {
    sub CONFIG_ATALK_MODULE () {	1;}
}
undef(&CONFIG_DEV_APPLETALK) if defined(&CONFIG_DEV_APPLETALK);
undef(&CONFIG_DECNET) if defined(&CONFIG_DECNET);
unless(defined(&CONFIG_DECNET_MODULE)) {
    sub CONFIG_DECNET_MODULE () {	1;}
}
unless(defined(&CONFIG_DECNET_SIOCGIFCONF)) {
    sub CONFIG_DECNET_SIOCGIFCONF () {	1;}
}
undef(&CONFIG_DECNET_ROUTER) if defined(&CONFIG_DECNET_ROUTER);
undef(&CONFIG_BRIDGE) if defined(&CONFIG_BRIDGE);
undef(&CONFIG_X25) if defined(&CONFIG_X25);
undef(&CONFIG_LAPB) if defined(&CONFIG_LAPB);
undef(&CONFIG_LLC) if defined(&CONFIG_LLC);
undef(&CONFIG_NET_DIVERT) if defined(&CONFIG_NET_DIVERT);
undef(&CONFIG_ECONET) if defined(&CONFIG_ECONET);
undef(&CONFIG_WAN_ROUTER) if defined(&CONFIG_WAN_ROUTER);
undef(&CONFIG_NET_FASTROUTE) if defined(&CONFIG_NET_FASTROUTE);
undef(&CONFIG_NET_HW_FLOWCONTROL) if defined(&CONFIG_NET_HW_FLOWCONTROL);
unless(defined(&CONFIG_NET_SCHED)) {
    sub CONFIG_NET_SCHED () {	1;}
}
undef(&CONFIG_NET_SCH_CBQ) if defined(&CONFIG_NET_SCH_CBQ);
unless(defined(&CONFIG_NET_SCH_CBQ_MODULE)) {
    sub CONFIG_NET_SCH_CBQ_MODULE () {	1;}
}
undef(&CONFIG_NET_SCH_HTB) if defined(&CONFIG_NET_SCH_HTB);
unless(defined(&CONFIG_NET_SCH_HTB_MODULE)) {
    sub CONFIG_NET_SCH_HTB_MODULE () {	1;}
}
undef(&CONFIG_NET_SCH_CSZ) if defined(&CONFIG_NET_SCH_CSZ);
unless(defined(&CONFIG_NET_SCH_CSZ_MODULE)) {
    sub CONFIG_NET_SCH_CSZ_MODULE () {	1;}
}
undef(&CONFIG_NET_SCH_PRIO) if defined(&CONFIG_NET_SCH_PRIO);
unless(defined(&CONFIG_NET_SCH_PRIO_MODULE)) {
    sub CONFIG_NET_SCH_PRIO_MODULE () {	1;}
}
undef(&CONFIG_NET_SCH_RED) if defined(&CONFIG_NET_SCH_RED);
unless(defined(&CONFIG_NET_SCH_RED_MODULE)) {
    sub CONFIG_NET_SCH_RED_MODULE () {	1;}
}
undef(&CONFIG_NET_SCH_SFQ) if defined(&CONFIG_NET_SCH_SFQ);
unless(defined(&CONFIG_NET_SCH_SFQ_MODULE)) {
    sub CONFIG_NET_SCH_SFQ_MODULE () {	1;}
}
undef(&CONFIG_NET_SCH_TEQL) if defined(&CONFIG_NET_SCH_TEQL);
unless(defined(&CONFIG_NET_SCH_TEQL_MODULE)) {
    sub CONFIG_NET_SCH_TEQL_MODULE () {	1;}
}
undef(&CONFIG_NET_SCH_TBF) if defined(&CONFIG_NET_SCH_TBF);
unless(defined(&CONFIG_NET_SCH_TBF_MODULE)) {
    sub CONFIG_NET_SCH_TBF_MODULE () {	1;}
}
undef(&CONFIG_NET_SCH_GRED) if defined(&CONFIG_NET_SCH_GRED);
unless(defined(&CONFIG_NET_SCH_GRED_MODULE)) {
    sub CONFIG_NET_SCH_GRED_MODULE () {	1;}
}
undef(&CONFIG_NET_SCH_DSMARK) if defined(&CONFIG_NET_SCH_DSMARK);
unless(defined(&CONFIG_NET_SCH_DSMARK_MODULE)) {
    sub CONFIG_NET_SCH_DSMARK_MODULE () {	1;}
}
undef(&CONFIG_NET_SCH_INGRESS) if defined(&CONFIG_NET_SCH_INGRESS);
unless(defined(&CONFIG_NET_SCH_INGRESS_MODULE)) {
    sub CONFIG_NET_SCH_INGRESS_MODULE () {	1;}
}
unless(defined(&CONFIG_NET_QOS)) {
    sub CONFIG_NET_QOS () {	1;}
}
unless(defined(&CONFIG_NET_ESTIMATOR)) {
    sub CONFIG_NET_ESTIMATOR () {	1;}
}
unless(defined(&CONFIG_NET_CLS)) {
    sub CONFIG_NET_CLS () {	1;}
}
undef(&CONFIG_NET_CLS_TCINDEX) if defined(&CONFIG_NET_CLS_TCINDEX);
unless(defined(&CONFIG_NET_CLS_TCINDEX_MODULE)) {
    sub CONFIG_NET_CLS_TCINDEX_MODULE () {	1;}
}
undef(&CONFIG_NET_CLS_ROUTE4) if defined(&CONFIG_NET_CLS_ROUTE4);
unless(defined(&CONFIG_NET_CLS_ROUTE4_MODULE)) {
    sub CONFIG_NET_CLS_ROUTE4_MODULE () {	1;}
}
unless(defined(&CONFIG_NET_CLS_ROUTE)) {
    sub CONFIG_NET_CLS_ROUTE () {	1;}
}
undef(&CONFIG_NET_CLS_FW) if defined(&CONFIG_NET_CLS_FW);
unless(defined(&CONFIG_NET_CLS_FW_MODULE)) {
    sub CONFIG_NET_CLS_FW_MODULE () {	1;}
}
undef(&CONFIG_NET_CLS_U32) if defined(&CONFIG_NET_CLS_U32);
unless(defined(&CONFIG_NET_CLS_U32_MODULE)) {
    sub CONFIG_NET_CLS_U32_MODULE () {	1;}
}
undef(&CONFIG_NET_CLS_RSVP) if defined(&CONFIG_NET_CLS_RSVP);
unless(defined(&CONFIG_NET_CLS_RSVP_MODULE)) {
    sub CONFIG_NET_CLS_RSVP_MODULE () {	1;}
}
undef(&CONFIG_NET_CLS_RSVP6) if defined(&CONFIG_NET_CLS_RSVP6);
unless(defined(&CONFIG_NET_CLS_RSVP6_MODULE)) {
    sub CONFIG_NET_CLS_RSVP6_MODULE () {	1;}
}
unless(defined(&CONFIG_NET_CLS_POLICE)) {
    sub CONFIG_NET_CLS_POLICE () {	1;}
}
undef(&CONFIG_NET_PKTGEN) if defined(&CONFIG_NET_PKTGEN);
unless(defined(&CONFIG_NET_PKTGEN_MODULE)) {
    sub CONFIG_NET_PKTGEN_MODULE () {	1;}
}
unless(defined(&CONFIG_IDE)) {
    sub CONFIG_IDE () {	1;}
}
unless(defined(&CONFIG_BLK_DEV_IDE)) {
    sub CONFIG_BLK_DEV_IDE () {	1;}
}
undef(&CONFIG_BLK_DEV_HD_IDE) if defined(&CONFIG_BLK_DEV_HD_IDE);
undef(&CONFIG_BLK_DEV_HD) if defined(&CONFIG_BLK_DEV_HD);
unless(defined(&CONFIG_BLK_DEV_IDEDISK)) {
    sub CONFIG_BLK_DEV_IDEDISK () {	1;}
}
undef(&CONFIG_IDEDISK_MULTI_MODE) if defined(&CONFIG_IDEDISK_MULTI_MODE);
undef(&CONFIG_IDEDISK_STROKE) if defined(&CONFIG_IDEDISK_STROKE);
undef(&CONFIG_BLK_DEV_IDECS) if defined(&CONFIG_BLK_DEV_IDECS);
unless(defined(&CONFIG_BLK_DEV_IDECD)) {
    sub CONFIG_BLK_DEV_IDECD () {	1;}
}
undef(&CONFIG_BLK_DEV_IDETAPE) if defined(&CONFIG_BLK_DEV_IDETAPE);
unless(defined(&CONFIG_BLK_DEV_IDETAPE_MODULE)) {
    sub CONFIG_BLK_DEV_IDETAPE_MODULE () {	1;}
}
undef(&CONFIG_BLK_DEV_IDEFLOPPY) if defined(&CONFIG_BLK_DEV_IDEFLOPPY);
unless(defined(&CONFIG_BLK_DEV_IDEFLOPPY_MODULE)) {
    sub CONFIG_BLK_DEV_IDEFLOPPY_MODULE () {	1;}
}
undef(&CONFIG_BLK_DEV_IDESCSI) if defined(&CONFIG_BLK_DEV_IDESCSI);
undef(&CONFIG_IDE_TASK_IOCTL) if defined(&CONFIG_IDE_TASK_IOCTL);
undef(&CONFIG_BLK_DEV_CMD640) if defined(&CONFIG_BLK_DEV_CMD640);
undef(&CONFIG_BLK_DEV_CMD640_ENHANCED) if defined(&CONFIG_BLK_DEV_CMD640_ENHANCED);
undef(&CONFIG_BLK_DEV_ISAPNP) if defined(&CONFIG_BLK_DEV_ISAPNP);
unless(defined(&CONFIG_BLK_DEV_IDEPCI)) {
    sub CONFIG_BLK_DEV_IDEPCI () {	1;}
}
unless(defined(&CONFIG_BLK_DEV_GENERIC)) {
    sub CONFIG_BLK_DEV_GENERIC () {	1;}
}
undef(&CONFIG_IDEPCI_SHARE_IRQ) if defined(&CONFIG_IDEPCI_SHARE_IRQ);
unless(defined(&CONFIG_BLK_DEV_IDEDMA_PCI)) {
    sub CONFIG_BLK_DEV_IDEDMA_PCI () {	1;}
}
undef(&CONFIG_BLK_DEV_OFFBOARD) if defined(&CONFIG_BLK_DEV_OFFBOARD);
undef(&CONFIG_BLK_DEV_IDEDMA_FORCED) if defined(&CONFIG_BLK_DEV_IDEDMA_FORCED);
unless(defined(&CONFIG_IDEDMA_PCI_AUTO)) {
    sub CONFIG_IDEDMA_PCI_AUTO () {	1;}
}
undef(&CONFIG_IDEDMA_ONLYDISK) if defined(&CONFIG_IDEDMA_ONLYDISK);
unless(defined(&CONFIG_BLK_DEV_IDEDMA)) {
    sub CONFIG_BLK_DEV_IDEDMA () {	1;}
}
undef(&CONFIG_IDEDMA_PCI_WIP) if defined(&CONFIG_IDEDMA_PCI_WIP);
undef(&CONFIG_BLK_DEV_ADMA100) if defined(&CONFIG_BLK_DEV_ADMA100);
undef(&CONFIG_BLK_DEV_AEC62XX) if defined(&CONFIG_BLK_DEV_AEC62XX);
unless(defined(&CONFIG_BLK_DEV_AEC62XX_MODULE)) {
    sub CONFIG_BLK_DEV_AEC62XX_MODULE () {	1;}
}
unless(defined(&CONFIG_BLK_DEV_ALI15X3)) {
    sub CONFIG_BLK_DEV_ALI15X3 () {	1;}
}
undef(&CONFIG_WDC_ALI15X3) if defined(&CONFIG_WDC_ALI15X3);
undef(&CONFIG_BLK_DEV_AMD74XX) if defined(&CONFIG_BLK_DEV_AMD74XX);
unless(defined(&CONFIG_BLK_DEV_AMD74XX_MODULE)) {
    sub CONFIG_BLK_DEV_AMD74XX_MODULE () {	1;}
}
undef(&CONFIG_AMD74XX_OVERRIDE) if defined(&CONFIG_AMD74XX_OVERRIDE);
unless(defined(&CONFIG_BLK_DEV_CMD64X)) {
    sub CONFIG_BLK_DEV_CMD64X () {	1;}
}
undef(&CONFIG_BLK_DEV_TRIFLEX) if defined(&CONFIG_BLK_DEV_TRIFLEX);
undef(&CONFIG_BLK_DEV_CY82C693) if defined(&CONFIG_BLK_DEV_CY82C693);
unless(defined(&CONFIG_BLK_DEV_CY82C693_MODULE)) {
    sub CONFIG_BLK_DEV_CY82C693_MODULE () {	1;}
}
undef(&CONFIG_BLK_DEV_CS5530) if defined(&CONFIG_BLK_DEV_CS5530);
unless(defined(&CONFIG_BLK_DEV_CS5530_MODULE)) {
    sub CONFIG_BLK_DEV_CS5530_MODULE () {	1;}
}
undef(&CONFIG_BLK_DEV_HPT34X) if defined(&CONFIG_BLK_DEV_HPT34X);
unless(defined(&CONFIG_BLK_DEV_HPT34X_MODULE)) {
    sub CONFIG_BLK_DEV_HPT34X_MODULE () {	1;}
}
undef(&CONFIG_HPT34X_AUTODMA) if defined(&CONFIG_HPT34X_AUTODMA);
undef(&CONFIG_BLK_DEV_HPT366) if defined(&CONFIG_BLK_DEV_HPT366);
unless(defined(&CONFIG_BLK_DEV_HPT366_MODULE)) {
    sub CONFIG_BLK_DEV_HPT366_MODULE () {	1;}
}
undef(&CONFIG_BLK_DEV_PIIX) if defined(&CONFIG_BLK_DEV_PIIX);
unless(defined(&CONFIG_BLK_DEV_PIIX_MODULE)) {
    sub CONFIG_BLK_DEV_PIIX_MODULE () {	1;}
}
unless(defined(&CONFIG_BLK_DEV_NS87415)) {
    sub CONFIG_BLK_DEV_NS87415 () {	1;}
}
undef(&CONFIG_BLK_DEV_OPTI621) if defined(&CONFIG_BLK_DEV_OPTI621);
unless(defined(&CONFIG_BLK_DEV_OPTI621_MODULE)) {
    sub CONFIG_BLK_DEV_OPTI621_MODULE () {	1;}
}
undef(&CONFIG_BLK_DEV_PDC202XX_OLD) if defined(&CONFIG_BLK_DEV_PDC202XX_OLD);
unless(defined(&CONFIG_BLK_DEV_PDC202XX_OLD_MODULE)) {
    sub CONFIG_BLK_DEV_PDC202XX_OLD_MODULE () {	1;}
}
undef(&CONFIG_PDC202XX_BURST) if defined(&CONFIG_PDC202XX_BURST);
undef(&CONFIG_BLK_DEV_PDC202XX_NEW) if defined(&CONFIG_BLK_DEV_PDC202XX_NEW);
unless(defined(&CONFIG_BLK_DEV_PDC202XX_NEW_MODULE)) {
    sub CONFIG_BLK_DEV_PDC202XX_NEW_MODULE () {	1;}
}
undef(&CONFIG_PDC202XX_FORCE) if defined(&CONFIG_PDC202XX_FORCE);
undef(&CONFIG_BLK_DEV_RZ1000) if defined(&CONFIG_BLK_DEV_RZ1000);
unless(defined(&CONFIG_BLK_DEV_RZ1000_MODULE)) {
    sub CONFIG_BLK_DEV_RZ1000_MODULE () {	1;}
}
undef(&CONFIG_BLK_DEV_SC1200) if defined(&CONFIG_BLK_DEV_SC1200);
unless(defined(&CONFIG_BLK_DEV_SC1200_MODULE)) {
    sub CONFIG_BLK_DEV_SC1200_MODULE () {	1;}
}
undef(&CONFIG_BLK_DEV_SVWKS) if defined(&CONFIG_BLK_DEV_SVWKS);
unless(defined(&CONFIG_BLK_DEV_SVWKS_MODULE)) {
    sub CONFIG_BLK_DEV_SVWKS_MODULE () {	1;}
}
undef(&CONFIG_BLK_DEV_SIIMAGE) if defined(&CONFIG_BLK_DEV_SIIMAGE);
unless(defined(&CONFIG_BLK_DEV_SIIMAGE_MODULE)) {
    sub CONFIG_BLK_DEV_SIIMAGE_MODULE () {	1;}
}
undef(&CONFIG_BLK_DEV_SIS5513) if defined(&CONFIG_BLK_DEV_SIS5513);
unless(defined(&CONFIG_BLK_DEV_SIS5513_MODULE)) {
    sub CONFIG_BLK_DEV_SIS5513_MODULE () {	1;}
}
undef(&CONFIG_BLK_DEV_SLC90E66) if defined(&CONFIG_BLK_DEV_SLC90E66);
unless(defined(&CONFIG_BLK_DEV_SLC90E66_MODULE)) {
    sub CONFIG_BLK_DEV_SLC90E66_MODULE () {	1;}
}
undef(&CONFIG_BLK_DEV_TRM290) if defined(&CONFIG_BLK_DEV_TRM290);
unless(defined(&CONFIG_BLK_DEV_TRM290_MODULE)) {
    sub CONFIG_BLK_DEV_TRM290_MODULE () {	1;}
}
undef(&CONFIG_BLK_DEV_VIA82CXXX) if defined(&CONFIG_BLK_DEV_VIA82CXXX);
unless(defined(&CONFIG_BLK_DEV_VIA82CXXX_MODULE)) {
    sub CONFIG_BLK_DEV_VIA82CXXX_MODULE () {	1;}
}
undef(&CONFIG_IDE_CHIPSETS) if defined(&CONFIG_IDE_CHIPSETS);
unless(defined(&CONFIG_IDEDMA_AUTO)) {
    sub CONFIG_IDEDMA_AUTO () {	1;}
}
undef(&CONFIG_IDEDMA_IVB) if defined(&CONFIG_IDEDMA_IVB);
undef(&CONFIG_DMA_NONPCI) if defined(&CONFIG_DMA_NONPCI);
unless(defined(&CONFIG_BLK_DEV_PDC202XX)) {
    sub CONFIG_BLK_DEV_PDC202XX () {	1;}
}
unless(defined(&CONFIG_BLK_DEV_IDE_MODES)) {
    sub CONFIG_BLK_DEV_IDE_MODES () {	1;}
}
undef(&CONFIG_BLK_DEV_ATARAID) if defined(&CONFIG_BLK_DEV_ATARAID);
unless(defined(&CONFIG_BLK_DEV_ATARAID_MODULE)) {
    sub CONFIG_BLK_DEV_ATARAID_MODULE () {	1;}
}
undef(&CONFIG_BLK_DEV_ATARAID_PDC) if defined(&CONFIG_BLK_DEV_ATARAID_PDC);
unless(defined(&CONFIG_BLK_DEV_ATARAID_PDC_MODULE)) {
    sub CONFIG_BLK_DEV_ATARAID_PDC_MODULE () {	1;}
}
undef(&CONFIG_BLK_DEV_ATARAID_HPT) if defined(&CONFIG_BLK_DEV_ATARAID_HPT);
unless(defined(&CONFIG_BLK_DEV_ATARAID_HPT_MODULE)) {
    sub CONFIG_BLK_DEV_ATARAID_HPT_MODULE () {	1;}
}
undef(&CONFIG_BLK_DEV_ATARAID_SII) if defined(&CONFIG_BLK_DEV_ATARAID_SII);
unless(defined(&CONFIG_SCSI)) {
    sub CONFIG_SCSI () {	1;}
}
unless(defined(&CONFIG_BLK_DEV_SD)) {
    sub CONFIG_BLK_DEV_SD () {	1;}
}
unless(defined(&CONFIG_SD_EXTRA_DEVS)) {
    sub CONFIG_SD_EXTRA_DEVS () {	(40);}
}
unless(defined(&CONFIG_CHR_DEV_ST)) {
    sub CONFIG_CHR_DEV_ST () {	1;}
}
undef(&CONFIG_CHR_DEV_OSST) if defined(&CONFIG_CHR_DEV_OSST);
unless(defined(&CONFIG_CHR_DEV_OSST_MODULE)) {
    sub CONFIG_CHR_DEV_OSST_MODULE () {	1;}
}
unless(defined(&CONFIG_BLK_DEV_SR)) {
    sub CONFIG_BLK_DEV_SR () {	1;}
}
unless(defined(&CONFIG_BLK_DEV_SR_VENDOR)) {
    sub CONFIG_BLK_DEV_SR_VENDOR () {	1;}
}
unless(defined(&CONFIG_SR_EXTRA_DEVS)) {
    sub CONFIG_SR_EXTRA_DEVS () {	(2);}
}
undef(&CONFIG_CHR_DEV_SG) if defined(&CONFIG_CHR_DEV_SG);
unless(defined(&CONFIG_CHR_DEV_SG_MODULE)) {
    sub CONFIG_CHR_DEV_SG_MODULE () {	1;}
}
unless(defined(&CONFIG_SCSI_MULTI_LUN)) {
    sub CONFIG_SCSI_MULTI_LUN () {	1;}
}
unless(defined(&CONFIG_SCSI_CONSTANTS)) {
    sub CONFIG_SCSI_CONSTANTS () {	1;}
}
undef(&CONFIG_SCSI_LOGGING) if defined(&CONFIG_SCSI_LOGGING);
unless(defined(&CONFIG_SCSI_SUNESP)) {
    sub CONFIG_SCSI_SUNESP () {	1;}
}
undef(&CONFIG_SCSI_QLOGICPTI) if defined(&CONFIG_SCSI_QLOGICPTI);
unless(defined(&CONFIG_SCSI_QLOGICPTI_MODULE)) {
    sub CONFIG_SCSI_QLOGICPTI_MODULE () {	1;}
}
undef(&CONFIG_SCSI_AIC7XXX) if defined(&CONFIG_SCSI_AIC7XXX);
unless(defined(&CONFIG_SCSI_AIC7XXX_MODULE)) {
    sub CONFIG_SCSI_AIC7XXX_MODULE () {	1;}
}
unless(defined(&CONFIG_AIC7XXX_CMDS_PER_DEVICE)) {
    sub CONFIG_AIC7XXX_CMDS_PER_DEVICE () {	(253);}
}
unless(defined(&CONFIG_AIC7XXX_RESET_DELAY_MS)) {
    sub CONFIG_AIC7XXX_RESET_DELAY_MS () {	(5000);}
}
undef(&CONFIG_AIC7XXX_PROBE_EISA_VL) if defined(&CONFIG_AIC7XXX_PROBE_EISA_VL);
undef(&CONFIG_AIC7XXX_BUILD_FIRMWARE) if defined(&CONFIG_AIC7XXX_BUILD_FIRMWARE);
undef(&CONFIG_AIC7XXX_DEBUG_ENABLE) if defined(&CONFIG_AIC7XXX_DEBUG_ENABLE);
unless(defined(&CONFIG_AIC7XXX_DEBUG_MASK)) {
    sub CONFIG_AIC7XXX_DEBUG_MASK () {	(0);}
}
undef(&CONFIG_AIC7XXX_REG_PRETTY_PRINT) if defined(&CONFIG_AIC7XXX_REG_PRETTY_PRINT);
undef(&CONFIG_SCSI_AIC79XX) if defined(&CONFIG_SCSI_AIC79XX);
undef(&CONFIG_SCSI_AIC7XXX_OLD) if defined(&CONFIG_SCSI_AIC7XXX_OLD);
unless(defined(&CONFIG_SCSI_AIC7XXX_OLD_MODULE)) {
    sub CONFIG_SCSI_AIC7XXX_OLD_MODULE () {	1;}
}
unless(defined(&CONFIG_AIC7XXX_OLD_TCQ_ON_BY_DEFAULT)) {
    sub CONFIG_AIC7XXX_OLD_TCQ_ON_BY_DEFAULT () {	1;}
}
unless(defined(&CONFIG_AIC7XXX_OLD_CMDS_PER_DEVICE)) {
    sub CONFIG_AIC7XXX_OLD_CMDS_PER_DEVICE () {	(8);}
}
unless(defined(&CONFIG_AIC7XXX_OLD_PROC_STATS)) {
    sub CONFIG_AIC7XXX_OLD_PROC_STATS () {	1;}
}
unless(defined(&CONFIG_SCSI_SYM53C8XX_2)) {
    sub CONFIG_SCSI_SYM53C8XX_2 () {	1;}
}
unless(defined(&CONFIG_SCSI_SYM53C8XX_DMA_ADDRESSING_MODE)) {
    sub CONFIG_SCSI_SYM53C8XX_DMA_ADDRESSING_MODE () {	(1);}
}
unless(defined(&CONFIG_SCSI_SYM53C8XX_DEFAULT_TAGS)) {
    sub CONFIG_SCSI_SYM53C8XX_DEFAULT_TAGS () {	(16);}
}
unless(defined(&CONFIG_SCSI_SYM53C8XX_MAX_TAGS)) {
    sub CONFIG_SCSI_SYM53C8XX_MAX_TAGS () {	(64);}
}
undef(&CONFIG_SCSI_SYM53C8XX_IOMAPPED) if defined(&CONFIG_SCSI_SYM53C8XX_IOMAPPED);
undef(&CONFIG_SCSI_QLOGIC_ISP) if defined(&CONFIG_SCSI_QLOGIC_ISP);
unless(defined(&CONFIG_SCSI_QLOGIC_ISP_MODULE)) {
    sub CONFIG_SCSI_QLOGIC_ISP_MODULE () {	1;}
}
unless(defined(&CONFIG_SCSI_QLOGIC_FC)) {
    sub CONFIG_SCSI_QLOGIC_FC () {	1;}
}
unless(defined(&CONFIG_SCSI_QLOGIC_FC_FIRMWARE)) {
    sub CONFIG_SCSI_QLOGIC_FC_FIRMWARE () {	1;}
}
undef(&CONFIG_FC4) if defined(&CONFIG_FC4);
unless(defined(&CONFIG_FC4_MODULE)) {
    sub CONFIG_FC4_MODULE () {	1;}
}
undef(&CONFIG_FC4_SOC) if defined(&CONFIG_FC4_SOC);
unless(defined(&CONFIG_FC4_SOC_MODULE)) {
    sub CONFIG_FC4_SOC_MODULE () {	1;}
}
undef(&CONFIG_FC4_SOCAL) if defined(&CONFIG_FC4_SOCAL);
unless(defined(&CONFIG_FC4_SOCAL_MODULE)) {
    sub CONFIG_FC4_SOCAL_MODULE () {	1;}
}
undef(&CONFIG_SCSI_PLUTO) if defined(&CONFIG_SCSI_PLUTO);
unless(defined(&CONFIG_SCSI_PLUTO_MODULE)) {
    sub CONFIG_SCSI_PLUTO_MODULE () {	1;}
}
undef(&CONFIG_SCSI_FCAL) if defined(&CONFIG_SCSI_FCAL);
unless(defined(&CONFIG_SCSI_FCAL_MODULE)) {
    sub CONFIG_SCSI_FCAL_MODULE () {	1;}
}
undef(&CONFIG_FUSION) if defined(&CONFIG_FUSION);
unless(defined(&CONFIG_FUSION_MODULE)) {
    sub CONFIG_FUSION_MODULE () {	1;}
}
undef(&CONFIG_FUSION_BOOT) if defined(&CONFIG_FUSION_BOOT);
unless(defined(&CONFIG_FUSION_MAX_SGE)) {
    sub CONFIG_FUSION_MAX_SGE () {	(40);}
}
undef(&CONFIG_FUSION_ISENSE) if defined(&CONFIG_FUSION_ISENSE);
unless(defined(&CONFIG_FUSION_ISENSE_MODULE)) {
    sub CONFIG_FUSION_ISENSE_MODULE () {	1;}
}
undef(&CONFIG_FUSION_CTL) if defined(&CONFIG_FUSION_CTL);
unless(defined(&CONFIG_FUSION_CTL_MODULE)) {
    sub CONFIG_FUSION_CTL_MODULE () {	1;}
}
undef(&CONFIG_FUSION_LAN) if defined(&CONFIG_FUSION_LAN);
unless(defined(&CONFIG_FUSION_LAN_MODULE)) {
    sub CONFIG_FUSION_LAN_MODULE () {	1;}
}
unless(defined(&CONFIG_NET_FC)) {
    sub CONFIG_NET_FC () {	1;}
}
undef(&CONFIG_IEEE1394) if defined(&CONFIG_IEEE1394);
unless(defined(&CONFIG_IEEE1394_MODULE)) {
    sub CONFIG_IEEE1394_MODULE () {	1;}
}
undef(&CONFIG_IEEE1394_PCILYNX) if defined(&CONFIG_IEEE1394_PCILYNX);
undef(&CONFIG_IEEE1394_OHCI1394) if defined(&CONFIG_IEEE1394_OHCI1394);
unless(defined(&CONFIG_IEEE1394_OHCI1394_MODULE)) {
    sub CONFIG_IEEE1394_OHCI1394_MODULE () {	1;}
}
undef(&CONFIG_IEEE1394_VIDEO1394) if defined(&CONFIG_IEEE1394_VIDEO1394);
undef(&CONFIG_IEEE1394_SBP2) if defined(&CONFIG_IEEE1394_SBP2);
unless(defined(&CONFIG_IEEE1394_SBP2_MODULE)) {
    sub CONFIG_IEEE1394_SBP2_MODULE () {	1;}
}
undef(&CONFIG_IEEE1394_SBP2_PHYS_DMA) if defined(&CONFIG_IEEE1394_SBP2_PHYS_DMA);
undef(&CONFIG_IEEE1394_ETH1394) if defined(&CONFIG_IEEE1394_ETH1394);
unless(defined(&CONFIG_IEEE1394_ETH1394_MODULE)) {
    sub CONFIG_IEEE1394_ETH1394_MODULE () {	1;}
}
undef(&CONFIG_IEEE1394_DV1394) if defined(&CONFIG_IEEE1394_DV1394);
unless(defined(&CONFIG_IEEE1394_DV1394_MODULE)) {
    sub CONFIG_IEEE1394_DV1394_MODULE () {	1;}
}
undef(&CONFIG_IEEE1394_RAWIO) if defined(&CONFIG_IEEE1394_RAWIO);
unless(defined(&CONFIG_IEEE1394_RAWIO_MODULE)) {
    sub CONFIG_IEEE1394_RAWIO_MODULE () {	1;}
}
undef(&CONFIG_IEEE1394_CMP) if defined(&CONFIG_IEEE1394_CMP);
unless(defined(&CONFIG_IEEE1394_CMP_MODULE)) {
    sub CONFIG_IEEE1394_CMP_MODULE () {	1;}
}
undef(&CONFIG_IEEE1394_AMDTP) if defined(&CONFIG_IEEE1394_AMDTP);
unless(defined(&CONFIG_IEEE1394_AMDTP_MODULE)) {
    sub CONFIG_IEEE1394_AMDTP_MODULE () {	1;}
}
undef(&CONFIG_IEEE1394_VERBOSEDEBUG) if defined(&CONFIG_IEEE1394_VERBOSEDEBUG);
unless(defined(&CONFIG_IEEE1394_OUI_DB)) {
    sub CONFIG_IEEE1394_OUI_DB () {	1;}
}
unless(defined(&CONFIG_NETDEVICES)) {
    sub CONFIG_NETDEVICES () {	1;}
}
undef(&CONFIG_ARCNET) if defined(&CONFIG_ARCNET);
undef(&CONFIG_DUMMY) if defined(&CONFIG_DUMMY);
unless(defined(&CONFIG_DUMMY_MODULE)) {
    sub CONFIG_DUMMY_MODULE () {	1;}
}
undef(&CONFIG_BONDING) if defined(&CONFIG_BONDING);
unless(defined(&CONFIG_BONDING_MODULE)) {
    sub CONFIG_BONDING_MODULE () {	1;}
}
undef(&CONFIG_EQUALIZER) if defined(&CONFIG_EQUALIZER);
unless(defined(&CONFIG_EQUALIZER_MODULE)) {
    sub CONFIG_EQUALIZER_MODULE () {	1;}
}
undef(&CONFIG_TUN) if defined(&CONFIG_TUN);
unless(defined(&CONFIG_TUN_MODULE)) {
    sub CONFIG_TUN_MODULE () {	1;}
}
undef(&CONFIG_ETHERTAP) if defined(&CONFIG_ETHERTAP);
unless(defined(&CONFIG_NET_ETHERNET)) {
    sub CONFIG_NET_ETHERNET () {	1;}
}
unless(defined(&CONFIG_SUNLANCE)) {
    sub CONFIG_SUNLANCE () {	1;}
}
unless(defined(&CONFIG_HAPPYMEAL)) {
    sub CONFIG_HAPPYMEAL () {	1;}
}
undef(&CONFIG_SUNBMAC) if defined(&CONFIG_SUNBMAC);
unless(defined(&CONFIG_SUNBMAC_MODULE)) {
    sub CONFIG_SUNBMAC_MODULE () {	1;}
}
undef(&CONFIG_SUNQE) if defined(&CONFIG_SUNQE);
unless(defined(&CONFIG_SUNQE_MODULE)) {
    sub CONFIG_SUNQE_MODULE () {	1;}
}
unless(defined(&CONFIG_SUNGEM)) {
    sub CONFIG_SUNGEM () {	1;}
}
unless(defined(&CONFIG_NET_VENDOR_3COM)) {
    sub CONFIG_NET_VENDOR_3COM () {	1;}
}
undef(&CONFIG_EL1) if defined(&CONFIG_EL1);
undef(&CONFIG_EL2) if defined(&CONFIG_EL2);
undef(&CONFIG_ELPLUS) if defined(&CONFIG_ELPLUS);
undef(&CONFIG_EL16) if defined(&CONFIG_EL16);
undef(&CONFIG_ELMC) if defined(&CONFIG_ELMC);
undef(&CONFIG_ELMC_II) if defined(&CONFIG_ELMC_II);
undef(&CONFIG_VORTEX) if defined(&CONFIG_VORTEX);
unless(defined(&CONFIG_VORTEX_MODULE)) {
    sub CONFIG_VORTEX_MODULE () {	1;}
}
undef(&CONFIG_TYPHOON) if defined(&CONFIG_TYPHOON);
unless(defined(&CONFIG_TYPHOON_MODULE)) {
    sub CONFIG_TYPHOON_MODULE () {	1;}
}
undef(&CONFIG_LANCE) if defined(&CONFIG_LANCE);
undef(&CONFIG_NET_VENDOR_SMC) if defined(&CONFIG_NET_VENDOR_SMC);
undef(&CONFIG_NET_VENDOR_RACAL) if defined(&CONFIG_NET_VENDOR_RACAL);
undef(&CONFIG_HP100) if defined(&CONFIG_HP100);
undef(&CONFIG_NET_ISA) if defined(&CONFIG_NET_ISA);
unless(defined(&CONFIG_NET_PCI)) {
    sub CONFIG_NET_PCI () {	1;}
}
undef(&CONFIG_PCNET32) if defined(&CONFIG_PCNET32);
unless(defined(&CONFIG_PCNET32_MODULE)) {
    sub CONFIG_PCNET32_MODULE () {	1;}
}
undef(&CONFIG_AMD8111_ETH) if defined(&CONFIG_AMD8111_ETH);
undef(&CONFIG_ADAPTEC_STARFIRE) if defined(&CONFIG_ADAPTEC_STARFIRE);
unless(defined(&CONFIG_ADAPTEC_STARFIRE_MODULE)) {
    sub CONFIG_ADAPTEC_STARFIRE_MODULE () {	1;}
}
undef(&CONFIG_APRICOT) if defined(&CONFIG_APRICOT);
undef(&CONFIG_B44) if defined(&CONFIG_B44);
unless(defined(&CONFIG_B44_MODULE)) {
    sub CONFIG_B44_MODULE () {	1;}
}
undef(&CONFIG_CS89x0) if defined(&CONFIG_CS89x0);
undef(&CONFIG_TULIP) if defined(&CONFIG_TULIP);
unless(defined(&CONFIG_TULIP_MODULE)) {
    sub CONFIG_TULIP_MODULE () {	1;}
}
undef(&CONFIG_TULIP_MWI) if defined(&CONFIG_TULIP_MWI);
undef(&CONFIG_TULIP_MMIO) if defined(&CONFIG_TULIP_MMIO);
undef(&CONFIG_DE4X5) if defined(&CONFIG_DE4X5);
unless(defined(&CONFIG_DE4X5_MODULE)) {
    sub CONFIG_DE4X5_MODULE () {	1;}
}
undef(&CONFIG_DGRS) if defined(&CONFIG_DGRS);
unless(defined(&CONFIG_DGRS_MODULE)) {
    sub CONFIG_DGRS_MODULE () {	1;}
}
undef(&CONFIG_DM9102) if defined(&CONFIG_DM9102);
undef(&CONFIG_EEPRO100) if defined(&CONFIG_EEPRO100);
unless(defined(&CONFIG_EEPRO100_MODULE)) {
    sub CONFIG_EEPRO100_MODULE () {	1;}
}
undef(&CONFIG_EEPRO100_PIO) if defined(&CONFIG_EEPRO100_PIO);
undef(&CONFIG_E100) if defined(&CONFIG_E100);
unless(defined(&CONFIG_E100_MODULE)) {
    sub CONFIG_E100_MODULE () {	1;}
}
undef(&CONFIG_LNE390) if defined(&CONFIG_LNE390);
undef(&CONFIG_FEALNX) if defined(&CONFIG_FEALNX);
unless(defined(&CONFIG_FEALNX_MODULE)) {
    sub CONFIG_FEALNX_MODULE () {	1;}
}
undef(&CONFIG_NATSEMI) if defined(&CONFIG_NATSEMI);
unless(defined(&CONFIG_NATSEMI_MODULE)) {
    sub CONFIG_NATSEMI_MODULE () {	1;}
}
undef(&CONFIG_NE2K_PCI) if defined(&CONFIG_NE2K_PCI);
unless(defined(&CONFIG_NE2K_PCI_MODULE)) {
    sub CONFIG_NE2K_PCI_MODULE () {	1;}
}
undef(&CONFIG_NE3210) if defined(&CONFIG_NE3210);
undef(&CONFIG_ES3210) if defined(&CONFIG_ES3210);
undef(&CONFIG_8139CP) if defined(&CONFIG_8139CP);
undef(&CONFIG_8139TOO) if defined(&CONFIG_8139TOO);
unless(defined(&CONFIG_8139TOO_MODULE)) {
    sub CONFIG_8139TOO_MODULE () {	1;}
}
undef(&CONFIG_8139TOO_PIO) if defined(&CONFIG_8139TOO_PIO);
undef(&CONFIG_8139TOO_TUNE_TWISTER) if defined(&CONFIG_8139TOO_TUNE_TWISTER);
undef(&CONFIG_8139TOO_8129) if defined(&CONFIG_8139TOO_8129);
undef(&CONFIG_8139_OLD_RX_RESET) if defined(&CONFIG_8139_OLD_RX_RESET);
undef(&CONFIG_SIS900) if defined(&CONFIG_SIS900);
unless(defined(&CONFIG_SIS900_MODULE)) {
    sub CONFIG_SIS900_MODULE () {	1;}
}
undef(&CONFIG_EPIC100) if defined(&CONFIG_EPIC100);
unless(defined(&CONFIG_EPIC100_MODULE)) {
    sub CONFIG_EPIC100_MODULE () {	1;}
}
undef(&CONFIG_SUNDANCE) if defined(&CONFIG_SUNDANCE);
unless(defined(&CONFIG_SUNDANCE_MODULE)) {
    sub CONFIG_SUNDANCE_MODULE () {	1;}
}
unless(defined(&CONFIG_SUNDANCE_MMIO)) {
    sub CONFIG_SUNDANCE_MMIO () {	1;}
}
undef(&CONFIG_TLAN) if defined(&CONFIG_TLAN);
undef(&CONFIG_VIA_RHINE) if defined(&CONFIG_VIA_RHINE);
unless(defined(&CONFIG_VIA_RHINE_MODULE)) {
    sub CONFIG_VIA_RHINE_MODULE () {	1;}
}
undef(&CONFIG_VIA_RHINE_MMIO) if defined(&CONFIG_VIA_RHINE_MMIO);
undef(&CONFIG_WINBOND_840) if defined(&CONFIG_WINBOND_840);
unless(defined(&CONFIG_WINBOND_840_MODULE)) {
    sub CONFIG_WINBOND_840_MODULE () {	1;}
}
undef(&CONFIG_NET_POCKET) if defined(&CONFIG_NET_POCKET);
undef(&CONFIG_ACENIC) if defined(&CONFIG_ACENIC);
unless(defined(&CONFIG_ACENIC_MODULE)) {
    sub CONFIG_ACENIC_MODULE () {	1;}
}
undef(&CONFIG_ACENIC_OMIT_TIGON_I) if defined(&CONFIG_ACENIC_OMIT_TIGON_I);
undef(&CONFIG_DL2K) if defined(&CONFIG_DL2K);
unless(defined(&CONFIG_DL2K_MODULE)) {
    sub CONFIG_DL2K_MODULE () {	1;}
}
undef(&CONFIG_E1000) if defined(&CONFIG_E1000);
unless(defined(&CONFIG_E1000_MODULE)) {
    sub CONFIG_E1000_MODULE () {	1;}
}
unless(defined(&CONFIG_E1000_NAPI)) {
    sub CONFIG_E1000_NAPI () {	1;}
}
undef(&CONFIG_MYRI_SBUS) if defined(&CONFIG_MYRI_SBUS);
unless(defined(&CONFIG_MYRI_SBUS_MODULE)) {
    sub CONFIG_MYRI_SBUS_MODULE () {	1;}
}
undef(&CONFIG_NS83820) if defined(&CONFIG_NS83820);
unless(defined(&CONFIG_NS83820_MODULE)) {
    sub CONFIG_NS83820_MODULE () {	1;}
}
undef(&CONFIG_HAMACHI) if defined(&CONFIG_HAMACHI);
undef(&CONFIG_YELLOWFIN) if defined(&CONFIG_YELLOWFIN);
unless(defined(&CONFIG_YELLOWFIN_MODULE)) {
    sub CONFIG_YELLOWFIN_MODULE () {	1;}
}
undef(&CONFIG_R8169) if defined(&CONFIG_R8169);
undef(&CONFIG_SK98LIN) if defined(&CONFIG_SK98LIN);
unless(defined(&CONFIG_SK98LIN_MODULE)) {
    sub CONFIG_SK98LIN_MODULE () {	1;}
}
undef(&CONFIG_TIGON3) if defined(&CONFIG_TIGON3);
unless(defined(&CONFIG_TIGON3_MODULE)) {
    sub CONFIG_TIGON3_MODULE () {	1;}
}
unless(defined(&CONFIG_FDDI)) {
    sub CONFIG_FDDI () {	1;}
}
undef(&CONFIG_DEFXX) if defined(&CONFIG_DEFXX);
undef(&CONFIG_SKFP) if defined(&CONFIG_SKFP);
unless(defined(&CONFIG_SKFP_MODULE)) {
    sub CONFIG_SKFP_MODULE () {	1;}
}
unless(defined(&CONFIG_HIPPI)) {
    sub CONFIG_HIPPI () {	1;}
}
undef(&CONFIG_ROADRUNNER) if defined(&CONFIG_ROADRUNNER);
undef(&CONFIG_PLIP) if defined(&CONFIG_PLIP);
unless(defined(&CONFIG_PLIP_MODULE)) {
    sub CONFIG_PLIP_MODULE () {	1;}
}
undef(&CONFIG_PPP) if defined(&CONFIG_PPP);
unless(defined(&CONFIG_PPP_MODULE)) {
    sub CONFIG_PPP_MODULE () {	1;}
}
undef(&CONFIG_PPP_MULTILINK) if defined(&CONFIG_PPP_MULTILINK);
undef(&CONFIG_PPP_FILTER) if defined(&CONFIG_PPP_FILTER);
undef(&CONFIG_PPP_ASYNC) if defined(&CONFIG_PPP_ASYNC);
undef(&CONFIG_PPP_SYNC_TTY) if defined(&CONFIG_PPP_SYNC_TTY);
undef(&CONFIG_PPP_DEFLATE) if defined(&CONFIG_PPP_DEFLATE);
undef(&CONFIG_PPP_BSDCOMP) if defined(&CONFIG_PPP_BSDCOMP);
undef(&CONFIG_PPPOE) if defined(&CONFIG_PPPOE);
unless(defined(&CONFIG_PPPOE_MODULE)) {
    sub CONFIG_PPPOE_MODULE () {	1;}
}
undef(&CONFIG_SLIP) if defined(&CONFIG_SLIP);
unless(defined(&CONFIG_SLIP_MODULE)) {
    sub CONFIG_SLIP_MODULE () {	1;}
}
unless(defined(&CONFIG_SLIP_COMPRESSED)) {
    sub CONFIG_SLIP_COMPRESSED () {	1;}
}
unless(defined(&CONFIG_SLIP_SMART)) {
    sub CONFIG_SLIP_SMART () {	1;}
}
undef(&CONFIG_SLIP_MODE_SLIP6) if defined(&CONFIG_SLIP_MODE_SLIP6);
undef(&CONFIG_NET_RADIO) if defined(&CONFIG_NET_RADIO);
undef(&CONFIG_TR) if defined(&CONFIG_TR);
unless(defined(&CONFIG_NET_FC)) {
    sub CONFIG_NET_FC () {	1;}
}
undef(&CONFIG_IPHASE5526) if defined(&CONFIG_IPHASE5526);
undef(&CONFIG_RCPCI) if defined(&CONFIG_RCPCI);
undef(&CONFIG_SHAPER) if defined(&CONFIG_SHAPER);
unless(defined(&CONFIG_SHAPER_MODULE)) {
    sub CONFIG_SHAPER_MODULE () {	1;}
}
undef(&CONFIG_WAN) if defined(&CONFIG_WAN);
unless(defined(&CONFIG_UNIX98_PTYS)) {
    sub CONFIG_UNIX98_PTYS () {	1;}
}
unless(defined(&CONFIG_UNIX98_PTY_COUNT)) {
    sub CONFIG_UNIX98_PTY_COUNT () {	(256);}
}
unless(defined(&CONFIG_VIDEO_DEV)) {
    sub CONFIG_VIDEO_DEV () {	1;}
}
undef(&CONFIG_VIDEO_BT848) if defined(&CONFIG_VIDEO_BT848);
unless(defined(&CONFIG_DRM_NEW)) {
    sub CONFIG_DRM_NEW () {	1;}
}
undef(&CONFIG_DRM_FFB) if defined(&CONFIG_DRM_FFB);
unless(defined(&CONFIG_DRM_FFB_MODULE)) {
    sub CONFIG_DRM_FFB_MODULE () {	1;}
}
undef(&CONFIG_DRM_TDFX) if defined(&CONFIG_DRM_TDFX);
unless(defined(&CONFIG_DRM_TDFX_MODULE)) {
    sub CONFIG_DRM_TDFX_MODULE () {	1;}
}
undef(&CONFIG_DRM_R128) if defined(&CONFIG_DRM_R128);
unless(defined(&CONFIG_INPUT)) {
    sub CONFIG_INPUT () {	1;}
}
unless(defined(&CONFIG_INPUT_KEYBDEV)) {
    sub CONFIG_INPUT_KEYBDEV () {	1;}
}
unless(defined(&CONFIG_INPUT_MOUSEDEV)) {
    sub CONFIG_INPUT_MOUSEDEV () {	1;}
}
unless(defined(&CONFIG_INPUT_MOUSEDEV_SCREEN_X)) {
    sub CONFIG_INPUT_MOUSEDEV_SCREEN_X () {	(1024);}
}
unless(defined(&CONFIG_INPUT_MOUSEDEV_SCREEN_Y)) {
    sub CONFIG_INPUT_MOUSEDEV_SCREEN_Y () {	(768);}
}
undef(&CONFIG_INPUT_JOYDEV) if defined(&CONFIG_INPUT_JOYDEV);
unless(defined(&CONFIG_INPUT_EVDEV)) {
    sub CONFIG_INPUT_EVDEV () {	1;}
}
undef(&CONFIG_QUOTA) if defined(&CONFIG_QUOTA);
undef(&CONFIG_QFMT_V2) if defined(&CONFIG_QFMT_V2);
undef(&CONFIG_AUTOFS_FS) if defined(&CONFIG_AUTOFS_FS);
unless(defined(&CONFIG_AUTOFS_FS_MODULE)) {
    sub CONFIG_AUTOFS_FS_MODULE () {	1;}
}
undef(&CONFIG_AUTOFS4_FS) if defined(&CONFIG_AUTOFS4_FS);
unless(defined(&CONFIG_AUTOFS4_FS_MODULE)) {
    sub CONFIG_AUTOFS4_FS_MODULE () {	1;}
}
undef(&CONFIG_REISERFS_FS) if defined(&CONFIG_REISERFS_FS);
undef(&CONFIG_REISERFS_CHECK) if defined(&CONFIG_REISERFS_CHECK);
undef(&CONFIG_REISERFS_PROC_INFO) if defined(&CONFIG_REISERFS_PROC_INFO);
undef(&CONFIG_ADFS_FS) if defined(&CONFIG_ADFS_FS);
undef(&CONFIG_ADFS_FS_RW) if defined(&CONFIG_ADFS_FS_RW);
undef(&CONFIG_AFFS_FS) if defined(&CONFIG_AFFS_FS);
unless(defined(&CONFIG_AFFS_FS_MODULE)) {
    sub CONFIG_AFFS_FS_MODULE () {	1;}
}
undef(&CONFIG_HFS_FS) if defined(&CONFIG_HFS_FS);
undef(&CONFIG_HFSPLUS_FS) if defined(&CONFIG_HFSPLUS_FS);
unless(defined(&CONFIG_HFSPLUS_FS_MODULE)) {
    sub CONFIG_HFSPLUS_FS_MODULE () {	1;}
}
undef(&CONFIG_BEFS_FS) if defined(&CONFIG_BEFS_FS);
unless(defined(&CONFIG_BEFS_FS_MODULE)) {
    sub CONFIG_BEFS_FS_MODULE () {	1;}
}
undef(&CONFIG_BEFS_DEBUG) if defined(&CONFIG_BEFS_DEBUG);
undef(&CONFIG_BFS_FS) if defined(&CONFIG_BFS_FS);
unless(defined(&CONFIG_BFS_FS_MODULE)) {
    sub CONFIG_BFS_FS_MODULE () {	1;}
}
undef(&CONFIG_EXT3_FS) if defined(&CONFIG_EXT3_FS);
unless(defined(&CONFIG_EXT3_FS_MODULE)) {
    sub CONFIG_EXT3_FS_MODULE () {	1;}
}
undef(&CONFIG_JBD) if defined(&CONFIG_JBD);
unless(defined(&CONFIG_JBD_MODULE)) {
    sub CONFIG_JBD_MODULE () {	1;}
}
undef(&CONFIG_JBD_DEBUG) if defined(&CONFIG_JBD_DEBUG);
undef(&CONFIG_FAT_FS) if defined(&CONFIG_FAT_FS);
unless(defined(&CONFIG_FAT_FS_MODULE)) {
    sub CONFIG_FAT_FS_MODULE () {	1;}
}
undef(&CONFIG_MSDOS_FS) if defined(&CONFIG_MSDOS_FS);
unless(defined(&CONFIG_MSDOS_FS_MODULE)) {
    sub CONFIG_MSDOS_FS_MODULE () {	1;}
}
undef(&CONFIG_UMSDOS_FS) if defined(&CONFIG_UMSDOS_FS);
undef(&CONFIG_VFAT_FS) if defined(&CONFIG_VFAT_FS);
unless(defined(&CONFIG_VFAT_FS_MODULE)) {
    sub CONFIG_VFAT_FS_MODULE () {	1;}
}
undef(&CONFIG_EFS_FS) if defined(&CONFIG_EFS_FS);
unless(defined(&CONFIG_EFS_FS_MODULE)) {
    sub CONFIG_EFS_FS_MODULE () {	1;}
}
undef(&CONFIG_JFFS_FS) if defined(&CONFIG_JFFS_FS);
undef(&CONFIG_JFFS2_FS) if defined(&CONFIG_JFFS2_FS);
undef(&CONFIG_CRAMFS) if defined(&CONFIG_CRAMFS);
undef(&CONFIG_TMPFS) if defined(&CONFIG_TMPFS);
unless(defined(&CONFIG_RAMFS)) {
    sub CONFIG_RAMFS () {	1;}
}
undef(&CONFIG_ISO9660_FS) if defined(&CONFIG_ISO9660_FS);
unless(defined(&CONFIG_ISO9660_FS_MODULE)) {
    sub CONFIG_ISO9660_FS_MODULE () {	1;}
}
unless(defined(&CONFIG_JOLIET)) {
    sub CONFIG_JOLIET () {	1;}
}
undef(&CONFIG_ZISOFS) if defined(&CONFIG_ZISOFS);
undef(&CONFIG_JFS_FS) if defined(&CONFIG_JFS_FS);
unless(defined(&CONFIG_JFS_FS_MODULE)) {
    sub CONFIG_JFS_FS_MODULE () {	1;}
}
undef(&CONFIG_JFS_DEBUG) if defined(&CONFIG_JFS_DEBUG);
undef(&CONFIG_JFS_STATISTICS) if defined(&CONFIG_JFS_STATISTICS);
undef(&CONFIG_MINIX_FS) if defined(&CONFIG_MINIX_FS);
unless(defined(&CONFIG_MINIX_FS_MODULE)) {
    sub CONFIG_MINIX_FS_MODULE () {	1;}
}
undef(&CONFIG_VXFS_FS) if defined(&CONFIG_VXFS_FS);
undef(&CONFIG_NTFS_FS) if defined(&CONFIG_NTFS_FS);
undef(&CONFIG_NTFS_RW) if defined(&CONFIG_NTFS_RW);
undef(&CONFIG_HPFS_FS) if defined(&CONFIG_HPFS_FS);
unless(defined(&CONFIG_HPFS_FS_MODULE)) {
    sub CONFIG_HPFS_FS_MODULE () {	1;}
}
unless(defined(&CONFIG_PROC_FS)) {
    sub CONFIG_PROC_FS () {	1;}
}
undef(&CONFIG_DEVFS_FS) if defined(&CONFIG_DEVFS_FS);
undef(&CONFIG_DEVFS_MOUNT) if defined(&CONFIG_DEVFS_MOUNT);
undef(&CONFIG_DEVFS_DEBUG) if defined(&CONFIG_DEVFS_DEBUG);
unless(defined(&CONFIG_DEVPTS_FS)) {
    sub CONFIG_DEVPTS_FS () {	1;}
}
undef(&CONFIG_QNX4FS_FS) if defined(&CONFIG_QNX4FS_FS);
undef(&CONFIG_QNX4FS_RW) if defined(&CONFIG_QNX4FS_RW);
undef(&CONFIG_ROMFS_FS) if defined(&CONFIG_ROMFS_FS);
unless(defined(&CONFIG_ROMFS_FS_MODULE)) {
    sub CONFIG_ROMFS_FS_MODULE () {	1;}
}
unless(defined(&CONFIG_EXT2_FS)) {
    sub CONFIG_EXT2_FS () {	1;}
}
undef(&CONFIG_SYSV_FS) if defined(&CONFIG_SYSV_FS);
unless(defined(&CONFIG_SYSV_FS_MODULE)) {
    sub CONFIG_SYSV_FS_MODULE () {	1;}
}
undef(&CONFIG_UDF_FS) if defined(&CONFIG_UDF_FS);
unless(defined(&CONFIG_UDF_FS_MODULE)) {
    sub CONFIG_UDF_FS_MODULE () {	1;}
}
unless(defined(&CONFIG_UDF_RW)) {
    sub CONFIG_UDF_RW () {	1;}
}
undef(&CONFIG_UFS_FS) if defined(&CONFIG_UFS_FS);
unless(defined(&CONFIG_UFS_FS_MODULE)) {
    sub CONFIG_UFS_FS_MODULE () {	1;}
}
unless(defined(&CONFIG_UFS_FS_WRITE)) {
    sub CONFIG_UFS_FS_WRITE () {	1;}
}
undef(&CONFIG_CODA_FS) if defined(&CONFIG_CODA_FS);
unless(defined(&CONFIG_CODA_FS_MODULE)) {
    sub CONFIG_CODA_FS_MODULE () {	1;}
}
undef(&CONFIG_INTERMEZZO_FS) if defined(&CONFIG_INTERMEZZO_FS);
unless(defined(&CONFIG_INTERMEZZO_FS_MODULE)) {
    sub CONFIG_INTERMEZZO_FS_MODULE () {	1;}
}
unless(defined(&CONFIG_NFS_FS)) {
    sub CONFIG_NFS_FS () {	1;}
}
unless(defined(&CONFIG_NFS_V3)) {
    sub CONFIG_NFS_V3 () {	1;}
}
undef(&CONFIG_NFS_DIRECTIO) if defined(&CONFIG_NFS_DIRECTIO);
undef(&CONFIG_ROOT_NFS) if defined(&CONFIG_ROOT_NFS);
undef(&CONFIG_NFSD) if defined(&CONFIG_NFSD);
unless(defined(&CONFIG_NFSD_MODULE)) {
    sub CONFIG_NFSD_MODULE () {	1;}
}
unless(defined(&CONFIG_NFSD_V3)) {
    sub CONFIG_NFSD_V3 () {	1;}
}
unless(defined(&CONFIG_NFSD_TCP)) {
    sub CONFIG_NFSD_TCP () {	1;}
}
unless(defined(&CONFIG_SUNRPC)) {
    sub CONFIG_SUNRPC () {	1;}
}
unless(defined(&CONFIG_LOCKD)) {
    sub CONFIG_LOCKD () {	1;}
}
unless(defined(&CONFIG_LOCKD_V4)) {
    sub CONFIG_LOCKD_V4 () {	1;}
}
undef(&CONFIG_SMB_FS) if defined(&CONFIG_SMB_FS);
undef(&CONFIG_NCP_FS) if defined(&CONFIG_NCP_FS);
undef(&CONFIG_NCPFS_PACKET_SIGNING) if defined(&CONFIG_NCPFS_PACKET_SIGNING);
undef(&CONFIG_NCPFS_IOCTL_LOCKING) if defined(&CONFIG_NCPFS_IOCTL_LOCKING);
undef(&CONFIG_NCPFS_STRONG) if defined(&CONFIG_NCPFS_STRONG);
undef(&CONFIG_NCPFS_NFS_NS) if defined(&CONFIG_NCPFS_NFS_NS);
undef(&CONFIG_NCPFS_OS2_NS) if defined(&CONFIG_NCPFS_OS2_NS);
undef(&CONFIG_NCPFS_SMALLDOS) if defined(&CONFIG_NCPFS_SMALLDOS);
undef(&CONFIG_NCPFS_NLS) if defined(&CONFIG_NCPFS_NLS);
undef(&CONFIG_NCPFS_EXTRAS) if defined(&CONFIG_NCPFS_EXTRAS);
undef(&CONFIG_ZISOFS_FS) if defined(&CONFIG_ZISOFS_FS);
undef(&CONFIG_PARTITION_ADVANCED) if defined(&CONFIG_PARTITION_ADVANCED);
unless(defined(&CONFIG_MSDOS_PARTITION)) {
    sub CONFIG_MSDOS_PARTITION () {	1;}
}
unless(defined(&CONFIG_SUN_PARTITION)) {
    sub CONFIG_SUN_PARTITION () {	1;}
}
undef(&CONFIG_SMB_NLS) if defined(&CONFIG_SMB_NLS);
unless(defined(&CONFIG_NLS)) {
    sub CONFIG_NLS () {	1;}
}
unless(defined(&CONFIG_NLS_DEFAULT)) {
    sub CONFIG_NLS_DEFAULT () {	"iso8859-1";}
}
undef(&CONFIG_NLS_CODEPAGE_437) if defined(&CONFIG_NLS_CODEPAGE_437);
undef(&CONFIG_NLS_CODEPAGE_737) if defined(&CONFIG_NLS_CODEPAGE_737);
undef(&CONFIG_NLS_CODEPAGE_775) if defined(&CONFIG_NLS_CODEPAGE_775);
undef(&CONFIG_NLS_CODEPAGE_850) if defined(&CONFIG_NLS_CODEPAGE_850);
undef(&CONFIG_NLS_CODEPAGE_852) if defined(&CONFIG_NLS_CODEPAGE_852);
undef(&CONFIG_NLS_CODEPAGE_855) if defined(&CONFIG_NLS_CODEPAGE_855);
undef(&CONFIG_NLS_CODEPAGE_857) if defined(&CONFIG_NLS_CODEPAGE_857);
undef(&CONFIG_NLS_CODEPAGE_860) if defined(&CONFIG_NLS_CODEPAGE_860);
undef(&CONFIG_NLS_CODEPAGE_861) if defined(&CONFIG_NLS_CODEPAGE_861);
undef(&CONFIG_NLS_CODEPAGE_862) if defined(&CONFIG_NLS_CODEPAGE_862);
undef(&CONFIG_NLS_CODEPAGE_863) if defined(&CONFIG_NLS_CODEPAGE_863);
undef(&CONFIG_NLS_CODEPAGE_864) if defined(&CONFIG_NLS_CODEPAGE_864);
undef(&CONFIG_NLS_CODEPAGE_865) if defined(&CONFIG_NLS_CODEPAGE_865);
undef(&CONFIG_NLS_CODEPAGE_866) if defined(&CONFIG_NLS_CODEPAGE_866);
undef(&CONFIG_NLS_CODEPAGE_869) if defined(&CONFIG_NLS_CODEPAGE_869);
undef(&CONFIG_NLS_CODEPAGE_936) if defined(&CONFIG_NLS_CODEPAGE_936);
undef(&CONFIG_NLS_CODEPAGE_950) if defined(&CONFIG_NLS_CODEPAGE_950);
undef(&CONFIG_NLS_CODEPAGE_932) if defined(&CONFIG_NLS_CODEPAGE_932);
undef(&CONFIG_NLS_CODEPAGE_949) if defined(&CONFIG_NLS_CODEPAGE_949);
undef(&CONFIG_NLS_CODEPAGE_874) if defined(&CONFIG_NLS_CODEPAGE_874);
undef(&CONFIG_NLS_ISO8859_8) if defined(&CONFIG_NLS_ISO8859_8);
undef(&CONFIG_NLS_CODEPAGE_1250) if defined(&CONFIG_NLS_CODEPAGE_1250);
undef(&CONFIG_NLS_CODEPAGE_1251) if defined(&CONFIG_NLS_CODEPAGE_1251);
undef(&CONFIG_NLS_ISO8859_1) if defined(&CONFIG_NLS_ISO8859_1);
undef(&CONFIG_NLS_ISO8859_2) if defined(&CONFIG_NLS_ISO8859_2);
undef(&CONFIG_NLS_ISO8859_3) if defined(&CONFIG_NLS_ISO8859_3);
undef(&CONFIG_NLS_ISO8859_4) if defined(&CONFIG_NLS_ISO8859_4);
undef(&CONFIG_NLS_ISO8859_5) if defined(&CONFIG_NLS_ISO8859_5);
undef(&CONFIG_NLS_ISO8859_6) if defined(&CONFIG_NLS_ISO8859_6);
undef(&CONFIG_NLS_ISO8859_7) if defined(&CONFIG_NLS_ISO8859_7);
undef(&CONFIG_NLS_ISO8859_9) if defined(&CONFIG_NLS_ISO8859_9);
undef(&CONFIG_NLS_ISO8859_13) if defined(&CONFIG_NLS_ISO8859_13);
undef(&CONFIG_NLS_ISO8859_14) if defined(&CONFIG_NLS_ISO8859_14);
undef(&CONFIG_NLS_ISO8859_15) if defined(&CONFIG_NLS_ISO8859_15);
undef(&CONFIG_NLS_KOI8_R) if defined(&CONFIG_NLS_KOI8_R);
undef(&CONFIG_NLS_KOI8_U) if defined(&CONFIG_NLS_KOI8_U);
undef(&CONFIG_NLS_UTF8) if defined(&CONFIG_NLS_UTF8);
undef(&CONFIG_SOUND) if defined(&CONFIG_SOUND);
unless(defined(&CONFIG_SOUND_MODULE)) {
    sub CONFIG_SOUND_MODULE () {	1;}
}
undef(&CONFIG_SOUND_ALI5455) if defined(&CONFIG_SOUND_ALI5455);
undef(&CONFIG_SOUND_BT878) if defined(&CONFIG_SOUND_BT878);
unless(defined(&CONFIG_SOUND_BT878_MODULE)) {
    sub CONFIG_SOUND_BT878_MODULE () {	1;}
}
undef(&CONFIG_SOUND_CMPCI) if defined(&CONFIG_SOUND_CMPCI);
undef(&CONFIG_SOUND_EMU10K1) if defined(&CONFIG_SOUND_EMU10K1);
undef(&CONFIG_MIDI_EMU10K1) if defined(&CONFIG_MIDI_EMU10K1);
undef(&CONFIG_SOUND_FUSION) if defined(&CONFIG_SOUND_FUSION);
undef(&CONFIG_SOUND_CS4281) if defined(&CONFIG_SOUND_CS4281);
undef(&CONFIG_SOUND_ES1370) if defined(&CONFIG_SOUND_ES1370);
undef(&CONFIG_SOUND_ES1371) if defined(&CONFIG_SOUND_ES1371);
unless(defined(&CONFIG_SOUND_ES1371_MODULE)) {
    sub CONFIG_SOUND_ES1371_MODULE () {	1;}
}
undef(&CONFIG_SOUND_ESSSOLO1) if defined(&CONFIG_SOUND_ESSSOLO1);
undef(&CONFIG_SOUND_MAESTRO) if defined(&CONFIG_SOUND_MAESTRO);
undef(&CONFIG_SOUND_MAESTRO3) if defined(&CONFIG_SOUND_MAESTRO3);
undef(&CONFIG_SOUND_FORTE) if defined(&CONFIG_SOUND_FORTE);
undef(&CONFIG_SOUND_ICH) if defined(&CONFIG_SOUND_ICH);
undef(&CONFIG_SOUND_RME96XX) if defined(&CONFIG_SOUND_RME96XX);
undef(&CONFIG_SOUND_SONICVIBES) if defined(&CONFIG_SOUND_SONICVIBES);
undef(&CONFIG_SOUND_TRIDENT) if defined(&CONFIG_SOUND_TRIDENT);
unless(defined(&CONFIG_SOUND_TRIDENT_MODULE)) {
    sub CONFIG_SOUND_TRIDENT_MODULE () {	1;}
}
undef(&CONFIG_SOUND_MSNDCLAS) if defined(&CONFIG_SOUND_MSNDCLAS);
undef(&CONFIG_SOUND_MSNDPIN) if defined(&CONFIG_SOUND_MSNDPIN);
undef(&CONFIG_SOUND_VIA82CXXX) if defined(&CONFIG_SOUND_VIA82CXXX);
undef(&CONFIG_MIDI_VIA82CXXX) if defined(&CONFIG_MIDI_VIA82CXXX);
undef(&CONFIG_SOUND_OSS) if defined(&CONFIG_SOUND_OSS);
undef(&CONFIG_SOUND_TVMIXER) if defined(&CONFIG_SOUND_TVMIXER);
undef(&CONFIG_SOUND_AD1980) if defined(&CONFIG_SOUND_AD1980);
unless(defined(&CONFIG_SOUND_AD1980_MODULE)) {
    sub CONFIG_SOUND_AD1980_MODULE () {	1;}
}
undef(&CONFIG_SOUND_WM97XX) if defined(&CONFIG_SOUND_WM97XX);
unless(defined(&CONFIG_SOUND_WM97XX_MODULE)) {
    sub CONFIG_SOUND_WM97XX_MODULE () {	1;}
}
unless(defined(&CONFIG_USB)) {
    sub CONFIG_USB () {	1;}
}
undef(&CONFIG_USB_DEBUG) if defined(&CONFIG_USB_DEBUG);
unless(defined(&CONFIG_USB_DEVICEFS)) {
    sub CONFIG_USB_DEVICEFS () {	1;}
}
undef(&CONFIG_USB_BANDWIDTH) if defined(&CONFIG_USB_BANDWIDTH);
undef(&CONFIG_USB_EHCI_HCD) if defined(&CONFIG_USB_EHCI_HCD);
unless(defined(&CONFIG_USB_UHCI)) {
    sub CONFIG_USB_UHCI () {	1;}
}
undef(&CONFIG_USB_UHCI_ALT) if defined(&CONFIG_USB_UHCI_ALT);
unless(defined(&CONFIG_USB_OHCI)) {
    sub CONFIG_USB_OHCI () {	1;}
}
undef(&CONFIG_USB_AUDIO) if defined(&CONFIG_USB_AUDIO);
undef(&CONFIG_USB_EMI26) if defined(&CONFIG_USB_EMI26);
undef(&CONFIG_USB_MIDI) if defined(&CONFIG_USB_MIDI);
unless(defined(&CONFIG_USB_MIDI_MODULE)) {
    sub CONFIG_USB_MIDI_MODULE () {	1;}
}
undef(&CONFIG_USB_STORAGE) if defined(&CONFIG_USB_STORAGE);
unless(defined(&CONFIG_USB_STORAGE_MODULE)) {
    sub CONFIG_USB_STORAGE_MODULE () {	1;}
}
undef(&CONFIG_USB_STORAGE_DEBUG) if defined(&CONFIG_USB_STORAGE_DEBUG);
undef(&CONFIG_USB_STORAGE_DATAFAB) if defined(&CONFIG_USB_STORAGE_DATAFAB);
unless(defined(&CONFIG_USB_STORAGE_FREECOM)) {
    sub CONFIG_USB_STORAGE_FREECOM () {	1;}
}
unless(defined(&CONFIG_USB_STORAGE_ISD200)) {
    sub CONFIG_USB_STORAGE_ISD200 () {	1;}
}
unless(defined(&CONFIG_USB_STORAGE_DPCM)) {
    sub CONFIG_USB_STORAGE_DPCM () {	1;}
}
unless(defined(&CONFIG_USB_STORAGE_HP8200e)) {
    sub CONFIG_USB_STORAGE_HP8200e () {	1;}
}
unless(defined(&CONFIG_USB_STORAGE_SDDR09)) {
    sub CONFIG_USB_STORAGE_SDDR09 () {	1;}
}
unless(defined(&CONFIG_USB_STORAGE_SDDR55)) {
    sub CONFIG_USB_STORAGE_SDDR55 () {	1;}
}
undef(&CONFIG_USB_STORAGE_JUMPSHOT) if defined(&CONFIG_USB_STORAGE_JUMPSHOT);
undef(&CONFIG_USB_ACM) if defined(&CONFIG_USB_ACM);
unless(defined(&CONFIG_USB_ACM_MODULE)) {
    sub CONFIG_USB_ACM_MODULE () {	1;}
}
undef(&CONFIG_USB_PRINTER) if defined(&CONFIG_USB_PRINTER);
unless(defined(&CONFIG_USB_PRINTER_MODULE)) {
    sub CONFIG_USB_PRINTER_MODULE () {	1;}
}
unless(defined(&CONFIG_USB_HID)) {
    sub CONFIG_USB_HID () {	1;}
}
unless(defined(&CONFIG_USB_HIDINPUT)) {
    sub CONFIG_USB_HIDINPUT () {	1;}
}
undef(&CONFIG_USB_HIDDEV) if defined(&CONFIG_USB_HIDDEV);
undef(&CONFIG_USB_AIPTEK) if defined(&CONFIG_USB_AIPTEK);
unless(defined(&CONFIG_USB_AIPTEK_MODULE)) {
    sub CONFIG_USB_AIPTEK_MODULE () {	1;}
}
undef(&CONFIG_USB_WACOM) if defined(&CONFIG_USB_WACOM);
unless(defined(&CONFIG_USB_WACOM_MODULE)) {
    sub CONFIG_USB_WACOM_MODULE () {	1;}
}
undef(&CONFIG_USB_KBTAB) if defined(&CONFIG_USB_KBTAB);
unless(defined(&CONFIG_USB_KBTAB_MODULE)) {
    sub CONFIG_USB_KBTAB_MODULE () {	1;}
}
undef(&CONFIG_USB_POWERMATE) if defined(&CONFIG_USB_POWERMATE);
unless(defined(&CONFIG_USB_POWERMATE_MODULE)) {
    sub CONFIG_USB_POWERMATE_MODULE () {	1;}
}
undef(&CONFIG_USB_DC2XX) if defined(&CONFIG_USB_DC2XX);
unless(defined(&CONFIG_USB_DC2XX_MODULE)) {
    sub CONFIG_USB_DC2XX_MODULE () {	1;}
}
undef(&CONFIG_USB_MDC800) if defined(&CONFIG_USB_MDC800);
unless(defined(&CONFIG_USB_MDC800_MODULE)) {
    sub CONFIG_USB_MDC800_MODULE () {	1;}
}
undef(&CONFIG_USB_SCANNER) if defined(&CONFIG_USB_SCANNER);
unless(defined(&CONFIG_USB_SCANNER_MODULE)) {
    sub CONFIG_USB_SCANNER_MODULE () {	1;}
}
undef(&CONFIG_USB_MICROTEK) if defined(&CONFIG_USB_MICROTEK);
unless(defined(&CONFIG_USB_MICROTEK_MODULE)) {
    sub CONFIG_USB_MICROTEK_MODULE () {	1;}
}
undef(&CONFIG_USB_HPUSBSCSI) if defined(&CONFIG_USB_HPUSBSCSI);
unless(defined(&CONFIG_USB_HPUSBSCSI_MODULE)) {
    sub CONFIG_USB_HPUSBSCSI_MODULE () {	1;}
}
undef(&CONFIG_USB_IBMCAM) if defined(&CONFIG_USB_IBMCAM);
unless(defined(&CONFIG_USB_IBMCAM_MODULE)) {
    sub CONFIG_USB_IBMCAM_MODULE () {	1;}
}
undef(&CONFIG_USB_KONICAWC) if defined(&CONFIG_USB_KONICAWC);
unless(defined(&CONFIG_USB_KONICAWC_MODULE)) {
    sub CONFIG_USB_KONICAWC_MODULE () {	1;}
}
undef(&CONFIG_USB_OV511) if defined(&CONFIG_USB_OV511);
unless(defined(&CONFIG_USB_OV511_MODULE)) {
    sub CONFIG_USB_OV511_MODULE () {	1;}
}
undef(&CONFIG_USB_PWC) if defined(&CONFIG_USB_PWC);
unless(defined(&CONFIG_USB_PWC_MODULE)) {
    sub CONFIG_USB_PWC_MODULE () {	1;}
}
undef(&CONFIG_USB_SE401) if defined(&CONFIG_USB_SE401);
unless(defined(&CONFIG_USB_SE401_MODULE)) {
    sub CONFIG_USB_SE401_MODULE () {	1;}
}
undef(&CONFIG_USB_STV680) if defined(&CONFIG_USB_STV680);
unless(defined(&CONFIG_USB_STV680_MODULE)) {
    sub CONFIG_USB_STV680_MODULE () {	1;}
}
undef(&CONFIG_USB_W9968CF) if defined(&CONFIG_USB_W9968CF);
undef(&CONFIG_USB_VICAM) if defined(&CONFIG_USB_VICAM);
unless(defined(&CONFIG_USB_VICAM_MODULE)) {
    sub CONFIG_USB_VICAM_MODULE () {	1;}
}
undef(&CONFIG_USB_DSBR) if defined(&CONFIG_USB_DSBR);
unless(defined(&CONFIG_USB_DSBR_MODULE)) {
    sub CONFIG_USB_DSBR_MODULE () {	1;}
}
undef(&CONFIG_USB_DABUSB) if defined(&CONFIG_USB_DABUSB);
unless(defined(&CONFIG_USB_DABUSB_MODULE)) {
    sub CONFIG_USB_DABUSB_MODULE () {	1;}
}
undef(&CONFIG_USB_PEGASUS) if defined(&CONFIG_USB_PEGASUS);
unless(defined(&CONFIG_USB_PEGASUS_MODULE)) {
    sub CONFIG_USB_PEGASUS_MODULE () {	1;}
}
undef(&CONFIG_USB_RTL8150) if defined(&CONFIG_USB_RTL8150);
unless(defined(&CONFIG_USB_RTL8150_MODULE)) {
    sub CONFIG_USB_RTL8150_MODULE () {	1;}
}
undef(&CONFIG_USB_KAWETH) if defined(&CONFIG_USB_KAWETH);
unless(defined(&CONFIG_USB_KAWETH_MODULE)) {
    sub CONFIG_USB_KAWETH_MODULE () {	1;}
}
undef(&CONFIG_USB_CATC) if defined(&CONFIG_USB_CATC);
unless(defined(&CONFIG_USB_CATC_MODULE)) {
    sub CONFIG_USB_CATC_MODULE () {	1;}
}
undef(&CONFIG_USB_AX8817X) if defined(&CONFIG_USB_AX8817X);
unless(defined(&CONFIG_USB_AX8817X_MODULE)) {
    sub CONFIG_USB_AX8817X_MODULE () {	1;}
}
undef(&CONFIG_USB_CDCETHER) if defined(&CONFIG_USB_CDCETHER);
unless(defined(&CONFIG_USB_CDCETHER_MODULE)) {
    sub CONFIG_USB_CDCETHER_MODULE () {	1;}
}
undef(&CONFIG_USB_USBNET) if defined(&CONFIG_USB_USBNET);
unless(defined(&CONFIG_USB_USBNET_MODULE)) {
    sub CONFIG_USB_USBNET_MODULE () {	1;}
}
undef(&CONFIG_USB_USS720) if defined(&CONFIG_USB_USS720);
unless(defined(&CONFIG_USB_USS720_MODULE)) {
    sub CONFIG_USB_USS720_MODULE () {	1;}
}
undef(&CONFIG_USB_SERIAL) if defined(&CONFIG_USB_SERIAL);
unless(defined(&CONFIG_USB_SERIAL_MODULE)) {
    sub CONFIG_USB_SERIAL_MODULE () {	1;}
}
undef(&CONFIG_USB_SERIAL_DEBUG) if defined(&CONFIG_USB_SERIAL_DEBUG);
unless(defined(&CONFIG_USB_SERIAL_GENERIC)) {
    sub CONFIG_USB_SERIAL_GENERIC () {	1;}
}
undef(&CONFIG_USB_SERIAL_BELKIN) if defined(&CONFIG_USB_SERIAL_BELKIN);
unless(defined(&CONFIG_USB_SERIAL_BELKIN_MODULE)) {
    sub CONFIG_USB_SERIAL_BELKIN_MODULE () {	1;}
}
undef(&CONFIG_USB_SERIAL_WHITEHEAT) if defined(&CONFIG_USB_SERIAL_WHITEHEAT);
unless(defined(&CONFIG_USB_SERIAL_WHITEHEAT_MODULE)) {
    sub CONFIG_USB_SERIAL_WHITEHEAT_MODULE () {	1;}
}
undef(&CONFIG_USB_SERIAL_DIGI_ACCELEPORT) if defined(&CONFIG_USB_SERIAL_DIGI_ACCELEPORT);
unless(defined(&CONFIG_USB_SERIAL_DIGI_ACCELEPORT_MODULE)) {
    sub CONFIG_USB_SERIAL_DIGI_ACCELEPORT_MODULE () {	1;}
}
undef(&CONFIG_USB_SERIAL_EMPEG) if defined(&CONFIG_USB_SERIAL_EMPEG);
unless(defined(&CONFIG_USB_SERIAL_EMPEG_MODULE)) {
    sub CONFIG_USB_SERIAL_EMPEG_MODULE () {	1;}
}
undef(&CONFIG_USB_SERIAL_FTDI_SIO) if defined(&CONFIG_USB_SERIAL_FTDI_SIO);
unless(defined(&CONFIG_USB_SERIAL_FTDI_SIO_MODULE)) {
    sub CONFIG_USB_SERIAL_FTDI_SIO_MODULE () {	1;}
}
undef(&CONFIG_USB_SERIAL_VISOR) if defined(&CONFIG_USB_SERIAL_VISOR);
unless(defined(&CONFIG_USB_SERIAL_VISOR_MODULE)) {
    sub CONFIG_USB_SERIAL_VISOR_MODULE () {	1;}
}
undef(&CONFIG_USB_SERIAL_IPAQ) if defined(&CONFIG_USB_SERIAL_IPAQ);
unless(defined(&CONFIG_USB_SERIAL_IPAQ_MODULE)) {
    sub CONFIG_USB_SERIAL_IPAQ_MODULE () {	1;}
}
undef(&CONFIG_USB_SERIAL_IR) if defined(&CONFIG_USB_SERIAL_IR);
undef(&CONFIG_USB_SERIAL_EDGEPORT) if defined(&CONFIG_USB_SERIAL_EDGEPORT);
unless(defined(&CONFIG_USB_SERIAL_EDGEPORT_MODULE)) {
    sub CONFIG_USB_SERIAL_EDGEPORT_MODULE () {	1;}
}
undef(&CONFIG_USB_SERIAL_EDGEPORT_TI) if defined(&CONFIG_USB_SERIAL_EDGEPORT_TI);
unless(defined(&CONFIG_USB_SERIAL_EDGEPORT_TI_MODULE)) {
    sub CONFIG_USB_SERIAL_EDGEPORT_TI_MODULE () {	1;}
}
undef(&CONFIG_USB_SERIAL_KEYSPAN_PDA) if defined(&CONFIG_USB_SERIAL_KEYSPAN_PDA);
unless(defined(&CONFIG_USB_SERIAL_KEYSPAN_PDA_MODULE)) {
    sub CONFIG_USB_SERIAL_KEYSPAN_PDA_MODULE () {	1;}
}
undef(&CONFIG_USB_SERIAL_KEYSPAN) if defined(&CONFIG_USB_SERIAL_KEYSPAN);
unless(defined(&CONFIG_USB_SERIAL_KEYSPAN_MODULE)) {
    sub CONFIG_USB_SERIAL_KEYSPAN_MODULE () {	1;}
}
undef(&CONFIG_USB_SERIAL_KEYSPAN_USA28) if defined(&CONFIG_USB_SERIAL_KEYSPAN_USA28);
undef(&CONFIG_USB_SERIAL_KEYSPAN_USA28X) if defined(&CONFIG_USB_SERIAL_KEYSPAN_USA28X);
undef(&CONFIG_USB_SERIAL_KEYSPAN_USA28XA) if defined(&CONFIG_USB_SERIAL_KEYSPAN_USA28XA);
undef(&CONFIG_USB_SERIAL_KEYSPAN_USA28XB) if defined(&CONFIG_USB_SERIAL_KEYSPAN_USA28XB);
undef(&CONFIG_USB_SERIAL_KEYSPAN_USA19) if defined(&CONFIG_USB_SERIAL_KEYSPAN_USA19);
undef(&CONFIG_USB_SERIAL_KEYSPAN_USA18X) if defined(&CONFIG_USB_SERIAL_KEYSPAN_USA18X);
undef(&CONFIG_USB_SERIAL_KEYSPAN_USA19W) if defined(&CONFIG_USB_SERIAL_KEYSPAN_USA19W);
undef(&CONFIG_USB_SERIAL_KEYSPAN_USA19QW) if defined(&CONFIG_USB_SERIAL_KEYSPAN_USA19QW);
undef(&CONFIG_USB_SERIAL_KEYSPAN_USA19QI) if defined(&CONFIG_USB_SERIAL_KEYSPAN_USA19QI);
undef(&CONFIG_USB_SERIAL_KEYSPAN_MPR) if defined(&CONFIG_USB_SERIAL_KEYSPAN_MPR);
undef(&CONFIG_USB_SERIAL_KEYSPAN_USA49W) if defined(&CONFIG_USB_SERIAL_KEYSPAN_USA49W);
undef(&CONFIG_USB_SERIAL_KEYSPAN_USA49WLC) if defined(&CONFIG_USB_SERIAL_KEYSPAN_USA49WLC);
undef(&CONFIG_USB_SERIAL_MCT_U232) if defined(&CONFIG_USB_SERIAL_MCT_U232);
unless(defined(&CONFIG_USB_SERIAL_MCT_U232_MODULE)) {
    sub CONFIG_USB_SERIAL_MCT_U232_MODULE () {	1;}
}
undef(&CONFIG_USB_SERIAL_KLSI) if defined(&CONFIG_USB_SERIAL_KLSI);
unless(defined(&CONFIG_USB_SERIAL_KLSI_MODULE)) {
    sub CONFIG_USB_SERIAL_KLSI_MODULE () {	1;}
}
undef(&CONFIG_USB_SERIAL_KOBIL_SCT) if defined(&CONFIG_USB_SERIAL_KOBIL_SCT);
unless(defined(&CONFIG_USB_SERIAL_KOBIL_SCT_MODULE)) {
    sub CONFIG_USB_SERIAL_KOBIL_SCT_MODULE () {	1;}
}
undef(&CONFIG_USB_SERIAL_PL2303) if defined(&CONFIG_USB_SERIAL_PL2303);
unless(defined(&CONFIG_USB_SERIAL_PL2303_MODULE)) {
    sub CONFIG_USB_SERIAL_PL2303_MODULE () {	1;}
}
undef(&CONFIG_USB_SERIAL_CYBERJACK) if defined(&CONFIG_USB_SERIAL_CYBERJACK);
unless(defined(&CONFIG_USB_SERIAL_CYBERJACK_MODULE)) {
    sub CONFIG_USB_SERIAL_CYBERJACK_MODULE () {	1;}
}
undef(&CONFIG_USB_SERIAL_XIRCOM) if defined(&CONFIG_USB_SERIAL_XIRCOM);
unless(defined(&CONFIG_USB_SERIAL_XIRCOM_MODULE)) {
    sub CONFIG_USB_SERIAL_XIRCOM_MODULE () {	1;}
}
undef(&CONFIG_USB_SERIAL_OMNINET) if defined(&CONFIG_USB_SERIAL_OMNINET);
unless(defined(&CONFIG_USB_SERIAL_OMNINET_MODULE)) {
    sub CONFIG_USB_SERIAL_OMNINET_MODULE () {	1;}
}
undef(&CONFIG_USB_RIO500) if defined(&CONFIG_USB_RIO500);
unless(defined(&CONFIG_USB_RIO500_MODULE)) {
    sub CONFIG_USB_RIO500_MODULE () {	1;}
}
undef(&CONFIG_USB_AUERSWALD) if defined(&CONFIG_USB_AUERSWALD);
undef(&CONFIG_USB_TIGL) if defined(&CONFIG_USB_TIGL);
unless(defined(&CONFIG_USB_TIGL_MODULE)) {
    sub CONFIG_USB_TIGL_MODULE () {	1;}
}
undef(&CONFIG_USB_BRLVGER) if defined(&CONFIG_USB_BRLVGER);
undef(&CONFIG_USB_LCD) if defined(&CONFIG_USB_LCD);
unless(defined(&CONFIG_USB_LCD_MODULE)) {
    sub CONFIG_USB_LCD_MODULE () {	1;}
}
unless(defined(&CONFIG_USB_GADGET)) {
    sub CONFIG_USB_GADGET () {	1;}
}
undef(&CONFIG_USB_GADGET_CONTROLLER) if defined(&CONFIG_USB_GADGET_CONTROLLER);
undef(&CONFIG_USB_NET2280) if defined(&CONFIG_USB_NET2280);
undef(&CONFIG_USB_GADGET_CONTROLLER) if defined(&CONFIG_USB_GADGET_CONTROLLER);
undef(&CONFIG_BLUEZ) if defined(&CONFIG_BLUEZ);
unless(defined(&CONFIG_BLUEZ_MODULE)) {
    sub CONFIG_BLUEZ_MODULE () {	1;}
}
undef(&CONFIG_BLUEZ_L2CAP) if defined(&CONFIG_BLUEZ_L2CAP);
unless(defined(&CONFIG_BLUEZ_L2CAP_MODULE)) {
    sub CONFIG_BLUEZ_L2CAP_MODULE () {	1;}
}
undef(&CONFIG_BLUEZ_SCO) if defined(&CONFIG_BLUEZ_SCO);
unless(defined(&CONFIG_BLUEZ_SCO_MODULE)) {
    sub CONFIG_BLUEZ_SCO_MODULE () {	1;}
}
undef(&CONFIG_BLUEZ_RFCOMM) if defined(&CONFIG_BLUEZ_RFCOMM);
unless(defined(&CONFIG_BLUEZ_RFCOMM_MODULE)) {
    sub CONFIG_BLUEZ_RFCOMM_MODULE () {	1;}
}
unless(defined(&CONFIG_BLUEZ_RFCOMM_TTY)) {
    sub CONFIG_BLUEZ_RFCOMM_TTY () {	1;}
}
undef(&CONFIG_BLUEZ_BNEP) if defined(&CONFIG_BLUEZ_BNEP);
unless(defined(&CONFIG_BLUEZ_BNEP_MODULE)) {
    sub CONFIG_BLUEZ_BNEP_MODULE () {	1;}
}
unless(defined(&CONFIG_BLUEZ_BNEP_MC_FILTER)) {
    sub CONFIG_BLUEZ_BNEP_MC_FILTER () {	1;}
}
unless(defined(&CONFIG_BLUEZ_BNEP_PROTO_FILTER)) {
    sub CONFIG_BLUEZ_BNEP_PROTO_FILTER () {	1;}
}
undef(&CONFIG_BLUEZ_HCIUSB) if defined(&CONFIG_BLUEZ_HCIUSB);
unless(defined(&CONFIG_BLUEZ_HCIUSB_MODULE)) {
    sub CONFIG_BLUEZ_HCIUSB_MODULE () {	1;}
}
unless(defined(&CONFIG_BLUEZ_USB_SCO)) {
    sub CONFIG_BLUEZ_USB_SCO () {	1;}
}
undef(&CONFIG_BLUEZ_HCIUART) if defined(&CONFIG_BLUEZ_HCIUART);
unless(defined(&CONFIG_BLUEZ_HCIUART_MODULE)) {
    sub CONFIG_BLUEZ_HCIUART_MODULE () {	1;}
}
unless(defined(&CONFIG_BLUEZ_HCIUART_H4)) {
    sub CONFIG_BLUEZ_HCIUART_H4 () {	1;}
}
unless(defined(&CONFIG_BLUEZ_HCIUART_BCSP)) {
    sub CONFIG_BLUEZ_HCIUART_BCSP () {	1;}
}
unless(defined(&CONFIG_BLUEZ_HCIUART_BCSP_TXCRC)) {
    sub CONFIG_BLUEZ_HCIUART_BCSP_TXCRC () {	1;}
}
undef(&CONFIG_BLUEZ_HCIBFUSB) if defined(&CONFIG_BLUEZ_HCIBFUSB);
unless(defined(&CONFIG_BLUEZ_HCIBFUSB_MODULE)) {
    sub CONFIG_BLUEZ_HCIBFUSB_MODULE () {	1;}
}
undef(&CONFIG_BLUEZ_HCIDTL1) if defined(&CONFIG_BLUEZ_HCIDTL1);
undef(&CONFIG_BLUEZ_HCIBT3C) if defined(&CONFIG_BLUEZ_HCIBT3C);
undef(&CONFIG_BLUEZ_HCIBLUECARD) if defined(&CONFIG_BLUEZ_HCIBLUECARD);
undef(&CONFIG_BLUEZ_HCIBTUART) if defined(&CONFIG_BLUEZ_HCIBTUART);
undef(&CONFIG_BLUEZ_HCIVHCI) if defined(&CONFIG_BLUEZ_HCIVHCI);
unless(defined(&CONFIG_BLUEZ_HCIVHCI_MODULE)) {
    sub CONFIG_BLUEZ_HCIVHCI_MODULE () {	1;}
}
undef(&CONFIG_SOFT_WATCHDOG) if defined(&CONFIG_SOFT_WATCHDOG);
unless(defined(&CONFIG_DEBUG_KERNEL)) {
    sub CONFIG_DEBUG_KERNEL () {	1;}
}
undef(&CONFIG_DEBUG_SLAB) if defined(&CONFIG_DEBUG_SLAB);
unless(defined(&CONFIG_MAGIC_SYSRQ)) {
    sub CONFIG_MAGIC_SYSRQ () {	1;}
}
undef(&CONFIG_DEBUG_SPINLOCK) if defined(&CONFIG_DEBUG_SPINLOCK);
undef(&CONFIG_DEBUG_BUGVERBOSE) if defined(&CONFIG_DEBUG_BUGVERBOSE);
undef(&CONFIG_DEBUG_DCFLUSH) if defined(&CONFIG_DEBUG_DCFLUSH);
undef(&CONFIG_STACK_DEBUG) if defined(&CONFIG_STACK_DEBUG);
unless(defined(&CONFIG_LOG_BUF_SHIFT)) {
    sub CONFIG_LOG_BUF_SHIFT () {	(0);}
}
unless(defined(&CONFIG_CRYPTO)) {
    sub CONFIG_CRYPTO () {	1;}
}
unless(defined(&CONFIG_CRYPTO_HMAC)) {
    sub CONFIG_CRYPTO_HMAC () {	1;}
}
undef(&CONFIG_CRYPTO_NULL) if defined(&CONFIG_CRYPTO_NULL);
unless(defined(&CONFIG_CRYPTO_NULL_MODULE)) {
    sub CONFIG_CRYPTO_NULL_MODULE () {	1;}
}
unless(defined(&CONFIG_CRYPTO_MD4)) {
    sub CONFIG_CRYPTO_MD4 () {	1;}
}
unless(defined(&CONFIG_CRYPTO_MD5)) {
    sub CONFIG_CRYPTO_MD5 () {	1;}
}
unless(defined(&CONFIG_CRYPTO_SHA1)) {
    sub CONFIG_CRYPTO_SHA1 () {	1;}
}
undef(&CONFIG_CRYPTO_SHA256) if defined(&CONFIG_CRYPTO_SHA256);
unless(defined(&CONFIG_CRYPTO_SHA256_MODULE)) {
    sub CONFIG_CRYPTO_SHA256_MODULE () {	1;}
}
undef(&CONFIG_CRYPTO_SHA512) if defined(&CONFIG_CRYPTO_SHA512);
unless(defined(&CONFIG_CRYPTO_SHA512_MODULE)) {
    sub CONFIG_CRYPTO_SHA512_MODULE () {	1;}
}
unless(defined(&CONFIG_CRYPTO_DES)) {
    sub CONFIG_CRYPTO_DES () {	1;}
}
undef(&CONFIG_CRYPTO_BLOWFISH) if defined(&CONFIG_CRYPTO_BLOWFISH);
unless(defined(&CONFIG_CRYPTO_BLOWFISH_MODULE)) {
    sub CONFIG_CRYPTO_BLOWFISH_MODULE () {	1;}
}
undef(&CONFIG_CRYPTO_TWOFISH) if defined(&CONFIG_CRYPTO_TWOFISH);
unless(defined(&CONFIG_CRYPTO_TWOFISH_MODULE)) {
    sub CONFIG_CRYPTO_TWOFISH_MODULE () {	1;}
}
undef(&CONFIG_CRYPTO_SERPENT) if defined(&CONFIG_CRYPTO_SERPENT);
unless(defined(&CONFIG_CRYPTO_SERPENT_MODULE)) {
    sub CONFIG_CRYPTO_SERPENT_MODULE () {	1;}
}
undef(&CONFIG_CRYPTO_AES) if defined(&CONFIG_CRYPTO_AES);
unless(defined(&CONFIG_CRYPTO_AES_MODULE)) {
    sub CONFIG_CRYPTO_AES_MODULE () {	1;}
}
undef(&CONFIG_CRYPTO_CAST5) if defined(&CONFIG_CRYPTO_CAST5);
unless(defined(&CONFIG_CRYPTO_CAST5_MODULE)) {
    sub CONFIG_CRYPTO_CAST5_MODULE () {	1;}
}
unless(defined(&CONFIG_CRYPTO_DEFLATE)) {
    sub CONFIG_CRYPTO_DEFLATE () {	1;}
}
undef(&CONFIG_CRYPTO_TEST) if defined(&CONFIG_CRYPTO_TEST);
unless(defined(&CONFIG_CRC32)) {
    sub CONFIG_CRC32 () {	1;}
}
unless(defined(&CONFIG_ZLIB_INFLATE)) {
    sub CONFIG_ZLIB_INFLATE () {	1;}
}
unless(defined(&CONFIG_ZLIB_DEFLATE)) {
    sub CONFIG_ZLIB_DEFLATE () {	1;}
}
undef(&CONFIG_FW_LOADER) if defined(&CONFIG_FW_LOADER);
unless(defined(&CONFIG_FW_LOADER_MODULE)) {
    sub CONFIG_FW_LOADER_MODULE () {	1;}
}
1;
